#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define F first
#define S second
const ll mod = 1e9 + 7;

struct Node {
    int left = -1;
    int right = -1;
    ll sum = 0;
    ll st = -1;

    Node() = default;

    Node(ll sum, ll st) : sum(sum), st(st) {}
};

vector<Node> tree;

void push(int v, ll vl, ll vr) {
    if (tree[v].st == -1) {
        return;
    }
    if (vr - vl != 1) {
        if (tree[v].left == -1) {
            tree[v].left = (int) tree.size();
            tree.emplace_back();
        }
        if (tree[v].right == -1) {
            tree[v].right = (int) tree.size();
            tree.emplace_back();
        }
        tree[tree[v].left].st = tree[v].st;
        tree[tree[v].right].st = tree[v].st;
    }
    tree[v].sum = (vr - vl) * tree[v].st;
    tree[v].st = -1;
}


ll get_sum(int v) {
    if (v == -1) return 0;
    return tree[v].sum;
}


int set_seg(int v, ll vl, ll vr, ll l, ll r, ll val) {
    if (l <= vl && vr <= r) {
        tree[v].st = val;
        push(v, vl, vr);
        return v;
    }
    push(v, vl, vr);
    if (l >= vr || vl >= r) return v;
    ll vm = (vl + vr) / 2;
    tree[v].left = set_seg(tree[v].left, vl, vm, l, r, val);
    tree[v].right = set_seg(tree[v].right, vm, vr, l, r, val);
    tree[v].sum = get_sum(tree[v].left) + get_sum(tree[v].right);
    return v;
}


ll sum_seg(int v, ll vl, ll vr, ll l, ll r) {
    push(v, vl, vr);
    if (l <= vl && vr <= r) return tree[v].sum;
    if (vl >= r || l >= vr) return 0;
    ll vm = (vl + vr) / 2;
    return
            sum_seg(tree[v].left, vl, vm, l, r) +
            sum_seg(tree[v].right, vm, vr, l, r);
}


void solve() {
    const ll lim = 2e9 + 100;
    int n;
    ll b, c;
    cin >> n >> b >> c;
    vector<pair<int, int>> gs(n);
    for (int i = 0; i < n; i++) {
        cin >> gs[i].second >> gs[i].first;
    }
    sort(gs.begin(), gs.end(), greater<>());
    int root = 0;
    tree.emplace_back();
    root = set_seg(root, 0, lim, 0, lim, 2 * b);
    for (auto &el: gs) {
        root = set_seg(root, 0, lim, el.second, el.second + c, el.first);
    }
    ll right = lim, left = 0;
    while (right - left > 1) {
        ll mid = (left + right) / 2;
        if (sum_seg(root, 0, lim, 0, mid) <= b) {
            left = mid;
        } else {
            right = mid;
        }
    }
    cout << left;
}


int main() {
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
