#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const int N = 2e5 + 5;
const int mod = 1e9 + 7;
const int INF = 2e18;

vector<int> dist, amount, amount_rev;
vector<set<int>> pr;
vector<vector<int>> pr_rev;
vector<bool> proc;
vector<pair<int, int>> g[N];

int calc_answer(int v, int l) {
    //cout << "calling calc_answer(" << v << "; " << l << ")" << endl;
    if (pr[v].size() == 0) return l == 0;
    int answer = 0;
    for (int u : pr[v])
        answer = (answer + calc_answer(u, l - dist[v] + dist[u])) % mod;
    if (!proc[v]) {
        proc[v] = true;
        for (auto& e : g[v]) {
            if (pr[v].find(e.first) != pr[v].end()) continue;
            //cout << "? " << v << " -> " << e.first << ": " << e.second + dist[e.first] << " == " << l << endl;
            if (e.second + dist[e.first] == l) {
                //cout << "! " << v << " " << e.first << " +" << amount_rev[v] * amount[e.first] << endl;
                answer = (answer + (amount_rev[v] * amount[e.first]) % mod) % mod;
            }
        }
    }
    return answer;
}

int dp_rev(int v, int s) {
    if (proc[v]) return amount_rev[v];
    if (pr_rev[v].size() == 0) {
        amount_rev[v] = v == s;
        proc[v] = true;
        return v == s;
    }
    int answer = 0;
    for (int u : pr_rev[v]) {
        answer = (answer + dp_rev(u, s)) % mod;
    }
    amount_rev[v] = answer;
    proc[v] = true;
    return answer;
}

int dp(int v, int s) {
    if (proc[v]) return amount[v];
    if (pr[v].size() == 0) {
        amount[v] = v == s;
        proc[v] = true;
        return v == s;
    }
    int answer = 0;
    for (int u : pr[v]) {
        answer = (answer + dp(u, s)) % mod;
    }
    amount[v] = answer;
    proc[v] = true;
    return answer;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    int s, t, L;
    cin >> s >> t >> L;
    --s, --t;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    set<pair<int, int>> st;
    st.insert({0, t});
    dist.assign(n, INF);
    pr.assign(n, set<int>());
    pr_rev.assign(n, vector<int>());
    proc.assign(n, false);
    amount.assign(n, 0);
    amount_rev.assign(n, 0);
    dist[t] = 0;
    while (!st.empty()) {
        int v = st.begin()->second;
        st.erase(st.begin());
        for (auto [u, w] : g[v]) {
            if (dist[u] >= dist[v] + w) {
                if (dist[u] > dist[v] + w) pr[u].clear();
                st.erase({dist[u], u});
                dist[u] = dist[v] + w;
                pr[u].insert(v);
                st.insert({dist[u], u});
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int x : pr[i]) {
            pr_rev[x].push_back(i);
        }
    }
    proc.assign(n, false);
    for (int i = 0; i < n; i++) {
        if (!proc[i]) dp(i, t);
    }
    proc.assign(n, false);
    for (int i = 0; i < n; i++) {
        if (!proc[i]) dp_rev(i, s);
    }
    for (int i = 0; i < n; i++) {
        amount[i] = max(1LL, amount[i]);
        amount_rev[i] = max(1LL, amount_rev[i]);
    }
    proc.assign(n, false);
    /*
    int i = 0;
    for (auto& s : pr) {
        cout << i << ":\t";
        for (int x : s)
            cout << x << ' ';
        cout << '\n';
        i++;
    }
    cout << "\n";
    for (int x : dist) {
        cout << x << ' ';
    }
    cout << "\n\n";
    for (int x : amount) {
        cout << x << ' ';
    }
    cout << "\n\n";
    for (int x : amount_rev) {
        cout << x << ' ';
    }
    cout << "\n\n";
     */
    cout << calc_answer(s, L);
}