#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
using pqg = priority_queue<T, vector<T>, greater<T>>;


#define int long long
#define fastIo(a) ios_base::sync_with_stdio(a); cin.tie(a); cout.tie(a)
#define all(a) a.begin(), a.end()
#define F first
#define S second
#define sz(a) (int)a.size()
#define pb push_back

const int N = 100100;

struct node {
    int pref = 0, suff = 0, v = 0;
    int flag = 0;
};

int n;

node merge(node a, node b) {
    auto[p1, s1, v1, f1] = a;
    auto[p2, s2, v2, f2] = b;
    int p, s, v, f;
    if (f1 && f2) {
        p = p1 + p2, s = s1 + s2, v = 0, f = 1;
    } else if (f1) {
        p = p1 + p2, s = s2, v = v2, f = 0;
    } else if (f2) {
        p = p1, s = s1 + s2, v = v1, f = 0;
    } else {
        p = p1, s = s2, v = v1 + v2 + (s1 + p2 - 1) / 2 * 2, f = 0;
    }
    return {p, s, v, f};
}

node t[4 * N];

void clear(int x = 1, int lx = 1, int rx = n + 1) {
    if (lx + 1 == rx) return (void) (t[x] = {1, 1, 0, 1});
    int mx = (lx + rx) / 2;
    clear(x << 1, lx, mx);
    clear(x << 1 | 1, mx, rx);
    t[x] = merge(t[x << 1], t[x << 1 | 1]);
}

void upd(int i, int x = 1, int lx = 1, int rx = n + 1) {
    if (lx + 1 == rx) return (void) (t[x] = {0, 0, 0, 0});
    int mx = (lx + rx) / 2;
    if (i < mx) upd(i, x << 1, lx, mx);
    else upd(i, x <<  1 | 1, mx, rx);
    t[x] = merge(t[x << 1], t[x << 1 | 1]);
}

node get(int l, int r, int x = 1, int lx = 1, int rx = n + 1) {
    if (l <= lx && rx <= r) return t[x];
    if (r <= lx || rx <= l) return {0, 0, 0, 0};
    int mx = (lx + rx) / 2;
    node left = get(l, r, x << 1, lx, mx);
    node right = get(l, r, x << 1 | 1, mx, rx);
    return merge(left, right);
}

int getv(int l, int r) {
    auto[p, s, v, f] = get(l, r, 1, 1, n + 1);
    if (f) {
        return (p - 1) / 2 * 2;
    } else {
        return v + (p - 1) / 2 * 2 + (s - 1) / 2 * 2;
    }
}

int st[2 * N];

void updv(int i) {
    for (st[i += N] = 1; i > 1; i >>= 1)
        st[i >> 1] = st[i] + st[i ^ 1];
}

int get_sum(int l, int r) {
    int res = 0;
    for (l += N, r += N; l < r; l >>= 1, r >>= 1) {
        if (l & 1) res += st[l++];
        if (r & 1) res += st[--r];
    }
    return res;
}

void solve() {
    cin >> n;
    vector<int> a(n);
    for (int &i : a)
        cin >> i;
    vector<pair<int, int>> b;
    for (int i = 0; i < n; i++)
        b.pb({a[i], i + 1});
    sort(all(b));
    reverse(all(b));
    int q;
    cin >> q;
    vector<int> l(q), r(q);
    for (int i = 0; i < q; i++)
        cin >> l[i] >> r[i];
    vector<int> ll(q, -1), rr(q, 1e9 + 1);
    vector<int> ord(q);
    iota(all(ord), 0);
    for (int tt = 0; tt < 40; tt++) {
        clear();
        memset(st, 0, sizeof st);
        sort(all(ord), [&](int i, int j) {
            return (rr[i] + ll[i]) / 2 > (rr[j] + ll[j]) / 2;
        });
        int ptr = 0;
        for (int i : ord) {
//            cerr << i << " " << l[i] << " " << r[i] << endl;
            int mm = (ll[i] + rr[i]) / 2;
            while (ptr < n && b[ptr].first >= mm) {
                int pos = b[ptr].second;
                upd(pos);
                updv(pos);
                ptr++;
            }
            int del = getv(l[i], r[i] + 1);
            int ones = get_sum(l[i], r[i] + 1);
            int zeros = r[i] - l[i] + 1 - ones;
            zeros -= del;
            if (ones > zeros) ll[i] = mm;
            else rr[i] = mm;
        }
    }
    sort(all(a));
    for (int i = 0; i < q; i++)
        cout << ll[i] << '\n';
}

int32_t main() {
    cout << fixed << setprecision(20);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}