#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef __int128 int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define int ll

const char en = '\n';
const int INF = 1e9 + 7;
const int INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

const int dx[4] = {1, -1, 0, 0};
const int dy[4] = {0, 0, 1, -1};

const int dxx[8] = {-1, -1, -1, 0, 1, 1, 1, 0};
const int dyy[8] = {-1, 0, 1, 1, 1, 0, -1, -1};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for (auto &x : a) {
        cin >> x;
    }
    int ptr = 0;
    bool border = false;
    vector<vector<int>> comp(n, vector<int> (m));
    function<void(int, int)> dfs = [&] (int x, int y) {
        comp[x][y] = ptr;
        for (int k = 0; k < 4; k++) {
            int nx = x + dx[k], ny = y + dy[k];
            if (nx >= 0 && nx < n && ny >= 0 && ny < m) {
                if (comp[nx][ny] == 0 && a[nx][ny] == '.') {
                    dfs(nx, ny);
                }
            } else {
                border = true;
            }
        }
    };
    int ozero = -1, ozx = -1, ozy = -1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '.' && comp[i][j] == 0) {
                ptr++;
                border = false;
                dfs(i, j);
                if (!border) {
                    ozero = ptr;
                    ozx = i - 1;
                    ozy = j - 1;
                    break;
                }
            }
        }
    }
    assert(ozero != -1);

    auto on_border = [&] (int x, int y) {
        for (int k = 0; k < 8; k++) {
            int nx = x + dxx[k], ny = y + dyy[k];
            if (nx >= 0 && nx < n && ny >= 0 && ny < m && comp[nx][ny] == ozero) {
                return true;
            }
        }
        return false;
    };

    int l = m, r = -1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (comp[i][j] == ozero) {
                l = min(l, j);
                r = max(r, j);
            }
        }
    }
    int pbeg = -1, pend = -1;
    vector<string> ans(n, string(m, '.'));
    {
        int begi = -1;
        for (int i = 0; i + 1 < n; i++) {
            if (comp[i + 1][l] == ozero) {
                begi = i;
                break;
            }
        }
        int endi = -1;
        for (int i = 0; i + 1 < n; i++) {
            if (comp[i + 1][r] == ozero) {
                endi = i;
                break;
            }
        }
        const int inf = 1e18;
        vector<vector<int>> d(n, vector<int> (m, inf)), p(n, vector<int> (m, -1));
        d[begi][l] = 0;
        p[begi][l] = -1;
        queue<pair<int, int>> q;
        q.push({begi, l});
        while (!q.empty()) {
            auto [x, y] = q.front();
            q.pop();
            for (int k = 0; k < 4; k++) {
                int nx = x + dx[k], ny = y + dy[k];
                if (ny >= l && ny <= r && nx >= 0 && nx < n && d[nx][ny] == inf && a[nx][ny] == '#') {
                    d[nx][ny] = d[x][y] + 1;
                    p[nx][ny] = k;
                    q.push({nx, ny});
                }
            }
        }
        int X = endi;
        int Y = r;
        while (1) {
            ans[X][Y] = '#';
            if (p[X][Y] == -1) {
                break;
            }
            int w = p[X][Y];
            X -= dx[w];
            Y -= dy[w];
        }
        pbeg = begi;
        pend = endi;
    }


    {
        int begi = -1;
        for (int i = n - 1; i > 0; i--) {
            if (comp[i - 1][l] == ozero) {
                begi = i;
                break;
            }
        }
        int endi = -1;
        for (int i = n - 1; i > 0; i--) {
            if (comp[i - 1][r] == ozero) {
                endi = i;
                break;
            }
        }
        for (int i = pbeg; i <= begi; i++) {
            ans[i][l - 1] = '#';
        }
        for (int i = pend; i <= endi; i++) {
            ans[i][r + 1] = '#';
        }
        const int inf = 1e18;
        vector<vector<int>> d(n, vector<int> (m, inf)), p(n, vector<int> (m, -1));
        d[begi][l] = 0;
        p[begi][l] = -1;
        queue<pair<int, int>> q;
        q.push({begi, l});
        while (!q.empty()) {
            auto [x, y] = q.front();
            q.pop();
            for (int k = 0; k < 4; k++) {
                int nx = x + dx[k], ny = y + dy[k];
                if (ny >= l && ny <= r && nx >= 0 && nx < n && d[nx][ny] == inf && a[nx][ny] == '#') {
                    d[nx][ny] = d[x][y] + 1;
                    p[nx][ny] = k;
                    q.push({nx, ny});
                }
            }
        }
        int X = endi;
        int Y = r;
        while (1) {
            ans[X][Y] = '#';
            if (p[X][Y] == -1) {
                break;
            }
            int w = p[X][Y];
            X -= dx[w];
            Y -= dy[w];
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (ans[i][j] == '#') {
                assert(a[i][j] == '#');
            }
        }
    }

    for (auto &x : ans) {
        cout << x << '\n';
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
