#ifdef Local
#include "debug.h"
#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define debug(...)
#endif
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x.size())
using namespace std;
typedef long double ld;
typedef long long ll;

namespace st {
    static const int size = 128 * 1024;
    int tree[size * 2 - 1];

    void add(int i, int val, int x = 0, int lx = 0, int rx = size) {
        if (rx - lx == 1) {
            tree[x] += val;
            return;
        }
        if (i < (lx + rx) / 2) {
            add(i, val, x * 2 + 1, lx, (lx + rx) / 2);
        } else {
            add(i, val, x * 2 + 2, (lx + rx) / 2, rx);
        }
        tree[x] = max(tree[x * 2 + 1], tree[x * 2 + 2]);
    }

    int get(int l, int r, int x = 0, int lx = 0, int rx = size) {
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        if (l >= rx || lx >= r) {
            return 0;
        }
        return max(get(l, r, x * 2 + 1, lx, (lx + rx) / 2),
                   get(l, r, x * 2 + 2, (lx + rx) / 2, rx));
    }
}

void solve() {
    int n, B, C;
    cin >> n >> B >> C;
    vector<int> x(n);
    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i];
    }
    set<pair<int, int>> Q;
    Q.insert({p[0], 0});
    int dist = 0;
    for (int i = 1; i < n; i++) {
        while (!Q.empty() && B) {
            int j = Q.begin()->second;
            if (st::get(j, st::size) == C || p[j] > B) {
                Q.erase(Q.begin());
            }
            int d = min({C - st::get(j, st::size), B / p[j], x[i] - x[i - 1]});
            dist += d;
            B -= p[j] * d;
            st::add(j, d);
            if (x[i - 1] + d == x[i]) {
                Q.insert({p[i], i});
                break;
            } else {
                cout << dist << "\n";
                return;
            }
        }
    }
    while (!Q.empty() && B) {
        int j = Q.begin()->second;
        if (st::get(j, st::size) == C || p[j] > B) {
            Q.erase(Q.begin());
        }
        int d = min(C - st::get(j, st::size), B / p[j]);
        dist += d;
        B -= p[j] * d;
        st::add(j, d);
    }
    cout << dist << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(12);
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}