#ifdef Local

#include "debug.h"

#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define debug(...)
#endif
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x.size())
using namespace std;
typedef long double ld;
typedef long long ll;

namespace st {
    static const int size = 8; // 128 * 1024;
    struct node {
        int val = 0;
        int add = 0;
    } tree[size * 2 - 1];

    void push(int x) {
        if (tree[x].add) {
            tree[x * 2 + 1].add += tree[x].add;
            tree[x * 2 + 1].val += tree[x].add;
            tree[x * 2 + 2].add += tree[x].add;
            tree[x * 2 + 2].val += tree[x].add;
            tree[x].add = 0;
        }
    }

    void add(int l, int r, int val, int x = 0, int lx = 0, int rx = size) {
        if (l <= lx && rx <= r) {
            tree[x].val += val;
            tree[x].add += val;
            return;
        }
        if (l >= rx || lx >= r) {
            return;
        }
        push(x);
        add(l, r, val, x * 2 + 1, lx, (lx + rx) / 2);
        add(l, r, val, x * 2 + 2, (lx + rx) / 2, rx);
        tree[x].val = max(tree[2 * x + 1].val, tree[2 * x + 2].val);
    }

    int get(int l, int r, int x = 0, int lx = 0, int rx = size) {
        if (l <= lx && rx <= r) {
            return tree[x].val;
        }
        if (l >= rx || lx >= r) {
            return INT32_MIN;
        }
        push(x);
        return max(get(l, r, x * 2 + 1, lx, (lx + rx) / 2),
                   get(l, r, x * 2 + 2, (lx + rx) / 2, rx));
    }
}

void gdb(int n) {
    for (int i = 0; i < n; i++) {
        cout << st::get(i, i + 1) << " ";
    }
    cout << endl;
}

void solve() {
    int n, B, C;
    cin >> n >> B >> C;
    vector<int> x(n);
    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i];
    }
    for (int i = 1; i < n; i++) {
        st::add(i, i + 1, -x[i]);
    }
    st::add(n, st::size, 10ll * INT32_MIN);
    set<pair<int, int>> Q;
    Q.insert({p[0], 0});
    int dist = 0;
    for (int i = 1; i < n; i++) {
        while (!Q.empty() && dist < x[i]) {
            int j = Q.begin()->second;
            int r = st::get(j, st::size);
            int d = min({max(0ll, C - r), B / p[j], x[i] - x[i - 1]});
            if (d == 0) {
                Q.erase(Q.begin());
                continue;
            }
            dist += d;
            B -= p[j] * d;
            st::add(j, st::size, d);
        }
        if (dist == x[i]) {
            Q.insert({p[i], i});
        }
    }
    while (!Q.empty()) {
        int j = Q.begin()->second;
        int d = min(C - st::get(j, st::size), B / p[j]);
        if (d == 0) {
            Q.erase(Q.begin());
            continue;
        }
        dist += d;
        B -= p[j] * d;
        st::add(j, st::size, d);
    }
    cout << dist << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(12);
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}