#include<bits/stdc++.h>

#define int long long
#define f first
#define s second
#define vec vector
#define sz(x) (int)(x).size()
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define pb push_back
#define all(x) x.begin(), x.end()
#define INF 1e18
#define pii pair<int, int>
#define rz resize

using namespace std;

int B, C;
int n;
vector<pii> a;

struct segtree{
    vec<pii> t;

    segtree (int n)
    {
        t.rz(4 * n);
    }

    void tree(int v, int vl, int vr)
    {
        if(vl == vr)
        {
            t[v].f = a[v].f + C;
            return;
        }
        int vm = vl + vr >> 1;

        tree(v * 2 + 1, vl, vm);
        tree(v * 2 + 2, vm + 1, vr);

        t[v].f = min(t[v * 2 + 1].f, t[v * 2 + 2].f);
    }

    void push(int v, int vl, int vr)
    {
        if(t[v].s)
        {
            t[v].f += t[v].s;

            if(vl != vr)
            {
                t[v * 2 + 1].s += t[v].s;
                t[v * 2 + 2].s += t[v].s;
            }

            t[v].s = 0;
        }
    }

    int get(int v, int vl, int vr, int l, int r)
    {
        push(v, vl, vr);

        if(vl > r || vr < l)
            return INF;
        if(l <= vl && vr <= r)
            return t[v].f;

        int vm = vl + vr >> 1;

        return min(get(v * 2 + 1, vl, vm, l, r), get(v * 2 + 2, vm + 1, vr, l, r));
    }

    void update(int v, int vl, int vr, int l, int r, int x)
    {
        push(v, vl, vr);

        if(vl > r || vr < l)
            return;
        if(l <= vl && vr <= r)
        {
            t[v].s += x;
            push(v, vl, vr);
            return;
        }

        int vm = vl + vr >> 1;

        update(v * 2 + 1, vl, vm, l, r, x);
        update(v * 2 + 2, vm + 1, vr, l, r, x);

        t[v].f = min(t[v * 2 + 1].f, t[v * 2 + 2].f);
    }
};

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> B >> C;
    n++;

    a.resize(n);

    FOR(i, n - 1)cin >> a[i].f >> a[i].s;

    a[n - 1] = {INF, 0};

    segtree t = segtree(n);

    t.tree(0, 0, n - 1);

    set<pii> s;

    int mod = 0;

    FOR(i, n - 1)
    {
        s.insert({a[i].s, i});
        int x = a[i].f, need = a[i + 1].f - x;
        while(true)
        {
            if(s.empty())
            {
                cout << x + 1;
                return 0;
            }
            if(!need)
            {
                break;
            }
            int cost = s.begin()->f, pos = s.begin()->s;
            int mx = t.get(0, 0, n - 1, pos, n - 1);
            int d = min(need, mx);
            if(B <= d * cost)
            {
                cout << x + B / cost + 1;
                return 0;
            }
            mx -= d;
            need -= d;
            x += d;
            B -= d * cost;
            if(mx == 0)
            {
                s.erase(s.begin());
            }
            t.update(0, 0, n - 1, pos, n - 1, -d);
        }
    }
}
