#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()
#define rep(i, a, b) for( auto i = a; i < b; i++)
#define forall(i, x) for(auto& i: x)
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)x.size())

using ll = long long;
using ld =  long double;
using ull = unsigned long long;

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int test = 0;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

const ll mod = 1e9 + 7;

vector<ll> dj(int st, vector<vector<pair<int, ll>>> & g) {
    int n = g.size() - 1;
    vector<ll> dp(n + 1, 2e18);
    dp[st] = 0;
    set<pair<ll, int>> s;
    s.insert({0, st});
    while (!s.empty()) {
        int u = s.begin()->second;
        s.erase(s.begin());
        for (auto [v, c] : g[u]) {
            if (dp[v] > dp[u] + c) {
                s.erase({dp[v], v});
                dp[v] = dp[u] + c;
                s.insert({dp[v], v});
            }
        }
    }
    return dp;
}

vector<vector<vector<int>>> G;
vector<vector<ll>> dp;

void dfs(int u, int T, vector<vector<ll>> & dist, vector<vector<pair<int, ll>>> & g, vector<int> & used) {
    used[u] = 1;
    for (auto [v, c] : g[u]) {
//        cout << u << " " << v << "\n";
//        cout << dist[T][u] + c + dist[T ^ 1][v] << " " << dist[T][v] << "\n";
        if (dist[T][u] + c + dist[T ^ 1][v] == dist[T][v] + dist[T ^ 1][v]) {
            G[T][u].push_back(v);
//            cout << u << " " << v << "\n";
            if (!used[v]) {
                dfs(v, T, dist, g, used);
            }
        }
    }
}

void dfs_dp(int u, int T) {
    for (auto v : G[T][u]) {
        dp[T][v] = (dp[T][v] + dp[T][u]) % mod;
        dfs_dp(v, T);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    int s, t;
    ll l;
    cin >> s >> t >> l;
    G.resize(2);
    dp.resize(2);
    G[0].resize(n + 1);
    G[1].resize(n + 1);
    dp[0].resize(n + 1);
    dp[1].resize(n + 1);
    vector<vector<pair<int, ll>>> g(n + 1);
    vector<tuple<int, int, ll>> edge(2 * m);
    for (int i = 0; i < m; i++) {
        int u, v;
        ll c;
        cin >> u >> v >> c;
        g[u].push_back({v, c});
        g[v].push_back({u, c});
        edge[2 * i] = {u, v, c};
        edge[2 * i + 1] = {v, u, c};
    }
    vector<vector<ll>> dist(2);
    dist[0] = dj(s, g);
    dist[1] = dj(t, g);
    vector<int> used(n + 1);
    dfs(s, 0, dist, g, used);
    used.assign(n + 1, 0);
    dfs(t, 1, dist, g, used);
    dp[0][s] = 1;
    dp[1][t] = 1;
    dfs_dp(s, 0);
    dfs_dp(t, 1);
    ll ans = 0;
    ll MIN = dist[0][t];
    for (auto [u, v, c] : edge) {
        if (MIN == dist[0][u] + c + dist[1][v] || MIN == dist[0][v] + c + dist[1][u]) continue;
        if (dist[0][u] + dist[1][v] + c != l) continue;
//        cout << u << " "<<  v << "\n";
//        cout << dp[0][u] << " " << dp[1][v] << "\n";
//        cout << "\n";
        ll left = dp[0][u] * dp[1][v] % mod;
        ans = (ans + left) % mod;
    }
//    ans = (ans + dp[0][t]) % mod;
    cout << ans << "\n";
}

int main() {
    fast();
    int t = 1;
    if (test) cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
