#include <bits/stdc++.h>

using namespace std;
using pii = pair<int, int>;

#pragma GCC optimaze("Ofast")
#pragma GCC target("sse,sse2,sse3,abm,avx,popcnt")

#define vec vector
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

#define endl '\n'

typedef int ll;
typedef long double ld;
typedef vec<ll> vll;
typedef pair<ll, ll> pll;

const ll inf = 1e18;
const int MOD = 1e9 + 7;

void dijkstra(int v, vector<ll>& d, vector<int>& cnt, const vector<vector<pii>>& g) {
    int n = g.size();
    d.assign(n, inf);
    cnt.assign(n, 0);
    vector<int> used(n, 0);
    set<pair<ll, int>> s;

    d[v] = 0;
    cnt[v] = 1;
    s.insert(pair<ll, int>(0, v));
    while (!s.empty()) {
        v = s.begin()->second;
        s.erase(s.begin());
        if (used[v]) {
            continue;
        }
        used[v] = 1;
        for (pii e : g[v]) {
            int to = e.first;
            if (d[to] > d[v] + e.second) {
                d[to] = d[v] + e.second;
                cnt[to] = cnt[v];
                s.insert(pair<ll, int>(d[to], to));
            } else if (d[to] == d[v] + e.second) {
                cnt[to] = (cnt[to] + cnt[v]) % MOD;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout.precision(20);

    int n, m, u, v, w, s, t;
    int l;
    cin >> n >> m >> s >> t >> l;
    --s;
    --t;
    vector<vector<pii>> g(n);
    for (int i = 0; i < m; ++i) {
        cin >> u >> v >> w;
        --u;
        --v;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }

    vector<ll> ds(n), dt(n);
    vector<int> cnts(n), cntt(n);
    dijkstra(s, ds, cnts, g);
    dijkstra(t, dt, cntt, g);

    if (l == ds[t]) {
        cout << cnts[t];
        return 0;
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (pii e : g[i]) {
            if (ds[i] + e.second != ds[e.first] && ds[i] + e.second + dt[e.first] == l) {
                ans = (ans + cnts[i] * 1LL * cntt[e.first]) % MOD;
            }
        }
    }

    cout << ans;

    return 0;
}
