#include <bits/stdc++.h>

using namespace  std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int inf = 2e9 + 1;
const int p = 1e9 + 7;
const int MAXN = 3e5+1;

struct min_stack{
    stack<pii> st;

    int size(){
        return st.size();
    }

    bool empty(){
        return st.empty();
    }
    void push(int x){
        if(st.empty()) st.push({x, x});
        else st.push({x, min(x, st.top().second  )});
    }
    void pop(){
        st.pop();
    }

    int get_min(){
        if(st.empty()) return inf;
        return st.top().second;
    }
    int top(){
        return st.top().first;
    }

};

struct min_queue{
    min_stack in, out;
    int get_min(){
        return min(in.get_min(), out.get_min()  );
    }
    void push(int x){
        in.push(x);
    }

    int size(){
        return in.size() + out.size();
    }

    void fix(){
        while (not in.empty()){
            out.push(in.top());
            in.pop();
        }
    }

    int front(){
        if(out.empty()) fix();
        return out.top();
    }

    void pop(){
        if(out.empty()) fix();
        out.pop();
    }
};


int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int n, b, c;
    cin >> n >> b >> c;
    vi x(n+1);
    vi p(n);
    for(int i = 0; i < n; ++i) cin  >> x[i] >> p[i];
    int sum = 0;
    x[n] = inf;
    int l = 0;
    min_queue q;
    int nearest = 0;
    while (true){
        if(l == x[nearest]){

            q.push(p[nearest]);
            ++nearest;
        }
        else{
            q.push(inf);
        }
        if(q.size() > c +1) q.pop();
        int cost = q.get_min();
        if(cost == inf or (sum + cost > b )) break;
        sum += cost;
        ++l;
    }
    cout << l;
    return 0;
}
