#include <bits/stdc++.h>

using namespace  std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int inf = 2e9 + 1;
const int MAXN = 1e5+1;

vi p(MAXN);

//bool cmp(pii &a, pii &b){
//    if(a.first != b.first) return a.first < b.first;
//    return a.second > b.second;
//}

struct Node{
    int x;
    int min_price;
    int max_index;
};

struct min_stack{
    stack<Node> st;
    int size(){
        return st.size();
    }
    bool empty(){
        return st.empty();
    }
    void pop(){
        st.pop();
    }
    int top(){
        return st.top().x;
    }

    void push(int x){
        if(st.empty()){
            st.push({x, p[x], x});
        }
        else {
            if(p[x] < st.top().min_price){
                st.push({x, p[x], x});
            }
            else if(p[x] == st.top().min_price and x > st.top().max_index){
                st.push({x, p[x], x});
            }
            else{
                st.push({x, st.top().min_price, st.top().max_index});
            }
        }
    }

    pii get_min(){
        if(st.empty()) return {inf, inf};
        return {st.top().min_price, -st.top().max_index};
    }


};

struct min_queue{
    min_stack in, out;
    pii get_min(){
        return min(in.get_min(), out.get_min());
    }
    void push(int x){
        in.push(x);
    }
    int size(){
        return in.size() + out.size();
    }
    void fix(){
        while (not in.empty()){
            out.push(in.top());
            in.pop();
        }
    }
    int front(){
        if(out.empty()) fix();
        return out.top();
    }

    void pop(){
        if(out.empty()) fix();
        out.pop();
    }
};


int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int n, b, c;
    cin >> n >> b >> c;
    vi x(n+1);
    for(int i = 0; i < n; ++i) cin  >> x[i] >> p[i];
    int sum = 0;
    x[n] = inf;
    int l = 0;
    min_queue q;
    int nearest = 0;
    while (true){
        if(l == x[nearest]){
            q.push(nearest);
            ++nearest;
        }
        while (  (q.size() != 0)  and (x[q.front()] <= l-c))  q.pop();
        pii cost = q.get_min();
        int min_price = cost.first;
        int max_index = -cost.second;
        if(min_price == inf or sum + min_price > b) break;
        int t = min(x[nearest] - l,  min(  (b - sum) / min_price , c - (l - x[max_index])  )   );
        sum += min_price * t;
        l += t;
    }
    cout << l;
    return 0;
}
