#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

using vi = vector<int>;
using vpi = vector<pair<int, int>>;
const int INF = 2e9 + 1;

vector<ll> tree;
vector<ll> a;

void build(ll i, ll l, ll r) {
    if (l + 1 == r) {
        tree[i] = a[l];
        return;
    }
    ll mid = (l + r) / 2;
    build(2 * i + 1, l, mid);
    build(2 * i + 2, mid, r);
    tree[i] = min(tree[2 * i + 1], tree[2 * i + 2]);
}

ll get(ll i, ll l, ll r, ll ql, ll qr) {
    if (r <= ql || qr <= l)
        return INF;
    if (ql <= l && r <= qr)
        return tree[i];
    ll mid = (l + r) / 2;
    return min(get(2 * i + 1, l, mid, ql, qr), get(2 * i + 2, mid, r, ql, qr));
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, b, c;
    cin >> n >> b >> c;
    vector<ll> cords(n);
    a.resize(n);
    tree.resize(4 * n, INF);
    for (int i = 0; i < n; ++i) {
        ll x, p;
        cin >> x >> p;
        a[i] = p;
        cords[i] = x;
    }
    for (int i = 0; i < n; ++i) {
        if (cords[i] + c > cords[n - 1]) {
            cords.push_back(cords[i] + c);
            a.push_back(INF);
        }
    }
    build(0, 0, n);
    ll l = 0;
    ll idx = 0;
    ll bu = 0;
    ll len = 0;
    for (int r = 1; r < cords.size(); ++r) {
        while (cords[r] - cords[l] > c) ++l;
        if (l == r) {
            len += min(c, b / a[r - 1]);
            break;
        }
        ll mi = get(0, 0, n, l, r);
        len += min(cords[r] - cords[r - 1], b / mi);
        b -= min(b, mi * (cords[r] - cords[r - 1]));
        if (b == 0) {
            break;
        }
    }
    cout << len << "\n";
    return 0;
}
