#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <deque>

using namespace std;
using ll = long long;
using ld = long double;

const ll inf = ll(1e18) * 2 + 36;
const int mod = int(1e9) + 7;

#define fast() ios::sync_with_stdio(0); cin.tie(0)
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

struct Edge {
	ll u, v, w;
};

int n, m;
vector<vector<char>>a, ans;
vector<vector<int>>used;
int cnt = 0;
bool f = 1;
void dfs(int i, int j) {
	used[i][j] = cnt;
	if (a[i][j + 1] == '(') {
		f = 1;
		return;
	}
	if (a[i + 1][j] == '(') {
		f = 1;
		return;
	}
	if (a[i][j - 1] == '(') {
		f = 1;
		return;
	}
	if (a[i - 1][j] == '(') {
		f = 1;
		return;
	}
	if (a[i][j + 1] != '#' && !used[i][j + 1]) {
		dfs(i, j + 1);
	}
	if (a[i + 1][j] != '#' && !used[i + 1][j]) {
		dfs(i + 1, j);
	}
	if (a[i][j - 1] != '#' && !used[i][j - 1]) {
		dfs(i, j - 1);
	}
	if (a[i - 1][j] != '#' && !used[i - 1][j]) {
		dfs(i - 1, j);
	}
}
signed main() {
	fast();
	cin >> n >> m;
	a.resize(n + 5, vector<char>(m + 5, '('));
	used.resize(n + 5, vector<int>(m + 5));
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			cin >> a[i][j];
		}
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			if (!used[i][j]) {
				if (a[i][j] == '#') continue;
				f = 0;
				cnt++;
				dfs(i, j);
				if (!f) break;
			}
		}
		if (!f) break;
	}

	/*for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			cout << used[i][j];
		}
		cout << '\n';
	}*/

	int verxi = 0, verxj = 0;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			if (used[i][j] == cnt) {
				verxi = i;
				verxj = j;
				break;
			}
		}
		if (verxi != 0 && verxj != 0) break;
	}
	int nisi = 0, nisj = 0;
	for (int i = n; i >= 1; i--) {
		for (int j = n; j >= 1; j--) {
			if (used[i][j] == cnt) {
				nisi = i;
				nisj = j;
				break;
			}
		}
		if (nisi != 0 && nisj != 0) break;
	}
	int levoi = 0, levoj = 0;
	for (int j = 1; j <= n; j++) {
		for (int i = n; i >= 1; i--) {
			if (used[i][j] == cnt) {
				levoi = i;
				levoj = j;
				break;
			}
		}
		if (levoi != 0 && levoj != 0) break;
	}
	int pravoi = 0, pravoj = 0;
	for (int j = n; j >= 1; j--) {
		for (int i = n; i >= 1; i--) {
			if (used[i][j] == cnt) {
				pravoi = i;
				pravoj = j;
				break;
			}
		}
		if (pravoi != 0 && pravoj != 0) break;
	}
	ans.resize(n + 5, vector<char>(m + 5, '.'));
	int i = verxi - 1, j = verxj;
	while (i != pravoi || j != pravoj + 1) {
		if (a[i][j + 1] == '#' && j != pravoj + 1) {
			j++;
			ans[i][j] = '#';
			continue;
		}
		i++;
		ans[i][j] = '#';
	}
	while (i != nisi + 1 || j != nisj) {
		if (a[i + 1][j] == '#' && i != nisi + 1) {
			i++;
			ans[i][j] = '#';
			continue;
		}
		j--;
		ans[i][j] = '#';
	}
	while (i != levoi || j != levoj - 1) {
		if (a[i][j - 1] == '#' && j != levoj - 1) {
			j--;
			ans[i][j] = '#';
			continue;
		}
		i--;
		ans[i][j] = '#';
	}
	while (i != verxi - 1 || j != verxj) {
		if (a[i - 1][j] == '#' && i != verxi - 1) {
			i--;
			ans[i][j] = '#';
			continue;
		}
		j++;
		ans[i][j] = '#';
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			cout << ans[i][j];
		}
		cout << '\n';
	}
	/*ll n, m;
	cin >> n >> m;
	ll s, f, L; cin >> s >> f >> L;
	s--; f--;
	vector <vector <pair <ll, ll>>> g(n);
	vector <Edge> r;
	while (m--) {
		ll u, v, w; cin >> u >> v >> w; u--; v--;
		g[u].push_back({ v, w });
		g[v].push_back({ u, w });
		r.push_back({ u, v, w });
	}
	vector <ll> df(n, inf), ds(n, inf);
	vector <vector <ll>> prf(n), prs(n);
	vector <ll> kf(n, 1), ks(n, 1);
	df[s] = 0;
	set <pair <ll, ll>> st;
	st.insert({ 0, s });
	while (!st.empty()) {
		ll v = st.begin()->second;
		st.erase(st.begin());
		for (auto& it : g[v]) {
			ll u = it.first, w = it.second;
			if (df[v] + w < df[u]) {
				st.erase({ df[u], u });
				df[u] = df[v] + w;
				st.insert({ df[u], u });
				prf[u].clear();
				prf[u].push_back(v);
				kf[u] = kf[v];
			}
			else if (df[v] + w == df[u]) {
				prf[u].push_back(v);
				kf[u] = (kf[u] + kf[v]) % mod;
			}
		}
	}
	ds[f] = 0;
	st.insert({ 0, f });
	while (!st.empty()) {
		ll v = st.begin()->first;
		st.erase(st.begin());
		for (auto& it : g[v]) {
			ll u = it.first; ll w = it.second;
			if (ds[v] + w < ds[u]) {
				st.erase({ ds[u], u });
				ds[u] = ds[v] + w;
				st.insert({ ds[u], u });
				prs[u].clear();
				prs[u].push_back(v);
				ks[u] = ks[v];
			}
			else if (ds[v] + w == ds[u]) {
				prs[u].push_back(v);
				ks[u] = (ks[u] + ks[v]) % mod;
			}
		}
	}
	for (auto& it : prf) {
		sort(all(it));
	}
	for (auto& it : prs) {
		sort(all(it));
	}
	set <ll> t;
	for (auto& i : prf) {
		for (auto& j : i) {
			t.insert(j);
		}
	}
	ll ans = 0;
	for (auto& it : r) {
		ll u = it.u, v = it.v, w = it.w;
		if (t.find(u) == t.end() && t.find(v) != t.end() && df[v] + ds[u] + w == L) {
			ans += kf[v] * ks[u];
		}
		if (t.find(v) == t.end() && t.find(u) != t.end() && df[u] + ds[v] + w == L) {
			ans += kf[u] * ks[v];
		}
		else if (t.find(v) != t.end() && t.find(u) != t.end()) {
			if (df[v] + ds[u] + w == L) {
				auto x = lower_bound(all(prf[v]), u);
				if (x == prf[v].end() || *x != u) {
					ans += kf[v] * ks[u];
				}
			}
			if (df[u] + ds[v] + w == L) {
				auto x = lower_bound(all(prf[u]), v);
				if (x == prf[u].end() || *x != v) {
					ans += kf[u] * ks[v];
				}
			}
		}
	}
	cout << ans + (df[f] == L ? kf[f] : 0);*/


	return 0;
}