#include <bits/stdc++.h>

using namespace std;

#define ll long long
//#define int long long
#define pb push_back

struct Seg {
    int cnt0, cnt1, len, sum, pref, suf;
};

Seg merge(const Seg &l, const Seg &r) {
    Seg ret;
    ret.cnt0 = l.cnt0 + r.cnt0;
    ret.cnt1 = l.cnt1 + r.cnt1;
    ret.len = l.len + r.len;
    ret.sum = l.sum + r.sum;
    ret.pref = l.pref == l.len ? l.len + r.pref : l.pref;
    ret.suf = r.suf == r.len ? r.len + l.suf : r.suf;
    if (l.suf > 0 && r.pref > 0) {
        ret.sum -= (l.suf - 1) / 2;
        ret.sum -= (r.pref - 1) / 2;
        ret.sum += (l.suf + r.pref - 1) / 2;
    }
    return ret;
}

Seg makeseg(int x) {
    Seg ret;
    if (x == 0) {
        ret.cnt0 = 1;
        ret.cnt1 = 0;
        ret.len = 1;
        ret.sum = 0;
        ret.pref = 1;
        ret.suf = 1;
    } else {
        ret.cnt0 = 0;
        ret.cnt1 = 1;
        ret.len = 1;
        ret.sum = 0;
        ret.pref = 0;
        ret.suf = 0;
    }
    return ret;
}

Seg makeempty() {
    Seg ret;
    ret.cnt0 = 0;
    ret.cnt1 = 0;
    ret.len = 0;
    ret.sum = 0;
    ret.pref = 0;
    ret.suf = 0;
    return ret;
}

const int N = 5e4 + 7;
const int M = 1e5 + 7;

int n, m;
int a[N];
vector<int> kek[N], lol[N];
int q;
int l[M], r[M];
int L[M], R[M], mid[M];
vector<int> arr;
Seg t[2 * N];

Seg get(int l, int r) {
    Seg retl = makeempty();
    Seg retr = makeempty();
    for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
        if (l & 1) {
            retl = merge(retl, t[l]);
            ++l;
        }
        if (r & 1) {
            --r;
            retr = merge(t[r], retr);
        }
    }
    return merge(retl, retr);
}

void upd(int i, int x) {
    i += n;
    t[i] = makeseg(x);
    for (i >>= 1; i > 0; i >>= 1) {
        t[i] = merge(t[2 * i], t[2 * i + 1]);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        arr.push_back(a[i]);
    }
    sort(arr.begin(), arr.end());
    arr.resize(unique(arr.begin(), arr.end()) - arr.begin());
    for (int i = 0; i < n; ++i) {
        a[i] = lower_bound(arr.begin(), arr.end(), a[i]) - arr.begin();
        kek[a[i]].push_back(i);
    }
    m = arr.size();
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> l[i] >> r[i];
        --l[i];
    }
    for (int i = 0; i < q; ++i) {
        L[i] = 0;
        R[i] = m;
    }
    for (int it = 0; it < 20; ++it) {
        for (int i = 0; i < m; ++i) {
            lol[i].clear();
        }
        for (int i = 0; i < q; ++i) {
            if (R[i] - L[i] != 1) {
                mid[i] = (L[i] + R[i]) / 2;
                lol[mid[i]].push_back(i);
            }
        }
        for (int i = 0; i < n; ++i) {
            t[i + n] = makeseg(1);
        }
        for (int i = n - 1; i > 0; --i) {
            t[i] = merge(t[2 * i], t[2 * i + 1]);
        }
        for (int i = 0; i < m; ++i) {
            for (int j : lol[i]) {
                Seg rofl = get(l[j], r[j]);
                if (rofl.cnt0 - 2 * rofl.sum < rofl.cnt1) {
                    L[j] = mid[j];
                } else {
                    R[j] = mid[j];
                }
            }
            for (int j : kek[i]) {
                upd(j, 0);
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << arr[L[i]] << "\n";
    }
    return 0;
}