#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll inf = 1e18;

constexpr int mod = 1e9 + 7;

using pii = pair<int, int>;

void get_odd(vector<pair<int, int>> &cycle, vector<vector<pii>> a) {
    int n = a.size(), m = a[0].size();
    cycle.clear();
    for (int j = 0; j < m - 2; ++j) {
        if (j % 2 == 0) {
            for (int i = 0; i < n; ++i) {
                if (i != 0 || j == 0) {
                    cycle.emplace_back(i, j);
                }
            }
        } else {
            for (int i = n - 1; i > 0; --i) {
                cycle.emplace_back(i, j);
            }
        }
    }
    cycle.emplace_back(n - 1, m - 2);
    for (int i = n - 2; i >= 0; --i) {
        if (i % 2 == 0) {
            cycle.emplace_back(i, m - 1);
            cycle.emplace_back(i, m - 2);
        } else {
            cycle.emplace_back(i, m - 2);
            cycle.emplace_back(i, m - 1);
        }
    }
    for (int j = m - 3; j > 0; --j) {
        cycle.emplace_back(0, j);
    }

    for (auto &[i, j] : cycle) {
        auto [x, y] = a[i][j];
        i = x, j = y;
    }
}

void transform(vector<vector<pii>> &a) {
    vector b(a[0].size(), vector<pii>(a.size()));
    for (int i = 0; i < a.size(); ++i) {
        for (int j = 0; j < a[i].size(); ++j) {
            b[j][(int)(a.size()) - i - 1] = a[i][j];
        }
    }
    swap(a, b);
}

char mv(pii a, pii b) {
//    assert(abs(a.first - b.first) + abs(a.second - b.second) == 1);
    if (abs(a.first - b.first) == 1) {
        return (a.first < b.first ? 'D' : 'U');
    } else {
        return (a.second < b.second ? 'R' : 'L');
    }
}

int ar, ac, br, bc, n, m;

vector<vector<int>> vals;

ll sum = 0;
void print(vector<pii> path) {
    if (path[0] == pair{br, bc}) {
        reverse(path.begin(), path.end());
    }
//    assert(path[0] == pair{ar, ac});
//    cout << path[0].first << " " << path[0].second << endl;
//    cout << path.back().first << " " << path.back().second << endl;
//    for (auto [x, y] : path) cout << x << " " << y << endl;
    for (int i = 0; i < (int)(path.size()) - 1; ++i) {
        cout << mv(path[i], path[i + 1]);
    }
    cout << '\n';
}

void sure(vector<pii> cycle) {
    int fi = find(cycle.begin(), cycle.end(), pair{ar, ac}) - cycle.begin();
    int se = find(cycle.begin(), cycle.end(), pair{br, bc}) - cycle.begin();
    if (fi > se) swap(fi, se);
    if (fi != cycle.size() && se != cycle.size()) {
        ll now = 0;
        for (int j = fi; j <= se; ++j) {
            now += vals[cycle[j].first][cycle[j].second];
        }
        if (now * 2 > sum) {
            print(vector(cycle.begin() + fi, cycle.begin() + se + 1));
            return;
        } else {
            vector<pii> path;
            for (int j = se; j < cycle.size(); ++j) path.push_back(cycle[j]);
            for (int j = 0; j <= fi; ++j) path.push_back(cycle[j]);
            now = 0;
            for (auto [x, y] : path) {
                now += vals[x][y];
            }
//            assert(now * 2 > sum);
            print(path);
            return;
        }
    }
}

void solve() {
    cin >> n >> m;
    cin >> ar >> ac >> br >> bc;
    vals = vector(n, vector<int>(m));
    ar--, ac--, br--, bc--;
    vector a(n, vector<pii>(m));
    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) a[i][j] = {i, j};
    sum = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> vals[i][j];
            sum += vals[i][j];
        }
    }
    vector<pair<int, int>> cycle;
    vector<vector<int>> pos(n, vector<int>(m));
    if (n % 2 == 0) {
        for (int i = 0; i < n; ++i) {
            if (i % 2 == 0) {
                for (int j = 0; j < m; ++j) {
                    if (j != 0 || i == 0) {
                        pos[i][j] = cycle.size();
                        cycle.emplace_back(i, j);
                    }
                }
            } else {
                for (int j = m - 1; j >= 0; --j) {
                    if (j != 0 || i == n - 1) {
                        pos[i][j] = cycle.size();
                        cycle.emplace_back(i, j);
                    }
                }
            }
        }
        for (int i = n - 2; i > 0; --i) {
            pos[i][0] = cycle.size();
            cycle.emplace_back(i, 0);
        }
    } else if (m % 2 == 0) {
        for (int j = 0; j < m; ++j) {
            if (j % 2 == 0) {
                for (int i = 0; i < n; ++i) {
                    if (i != 0 || j == 0) {
                        pos[i][j] = cycle.size();
                        cycle.emplace_back(i, j);
                    }
                }
            } else {
                for (int i = n - 1; i >= 0; --i) {
                    if (i != 0 || j == m - 1) {
                        pos[i][j] = cycle.size();
                        cycle.emplace_back(i, j);
                    }
                }
            }
        }
        for (int j = m - 2; j > 0; --j) {
            pos[0][j] = cycle.size();
            cycle.emplace_back(0, j);
        }
    } else {
        for (int _ = 0; _ < 4; ++_) {
            get_odd(cycle, a);
            int fi = find(cycle.begin(), cycle.end(), pair{ar, ac}) - cycle.begin();
            int se = find(cycle.begin(), cycle.end(), pair{br, bc}) - cycle.begin();
            if (fi > se) swap(fi, se);
            if (fi != cycle.size() && se != cycle.size()) {
                sure(cycle);
                return;
            }
            transform(a);
        }
//        assert(false);
    }
    sure(cycle);
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}
