#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct Edge {
    ll u, v, w;
};

ll mod = 1e9 + 7;

ll inf = 1e15;

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m;
    cin >> n >> m;
    ll s, t, L;
    cin >> s >> t >> L;
    s--;
    t--;
    vector<vector<pair<ll, ll>>> g(n);
    vector<Edge> edges;
    for (ll i = 0; i < m; i++) {
        ll u, v, w;
        cin >> u >> v >> w;
        edges.push_back({u - 1, v - 1, w});
        edges.push_back({v - 1, u - 1, w});
        g[u - 1].emplace_back(v - 1, w);
        g[v - 1].emplace_back(u - 1, w);
    }
    vector<bool> used(n);
    vector<ll> dist_t(n, inf), ways_t(n);
    priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<>> q;
    dist_t[t] = 0;
    ways_t[t] = 1;
    q.emplace(0, t);
    while (!q.empty()) {
        auto gg = q.top();
        q.pop();
        ll v = gg.second;
        if (used[v]) {
            continue;
        }
        used[v] = true;
        for (auto &to: g[v]) {
            if (dist_t[to.first] > dist_t[v] + to.second) {
                dist_t[to.first] = dist_t[v] + to.second;
                ways_t[to.first] = ways_t[v];
                q.emplace(dist_t[to.first], to.first);
            } else if (dist_t[to.first] == dist_t[v] + to.second) {
                ways_t[to.first] = (ways_t[to.first] + ways_t[v]) % mod;
            }
        }
    }
    vector<ll> dist_s(n, inf), ways_s(n);
    used.assign(n, false);
    dist_s[s] = 0;
    ways_s[s] = 1;
    q.emplace(0, s);

    while (!q.empty()) {
        auto gg = q.top();
        q.pop();
        ll v = gg.second;
        if (used[v]) {
            continue;
        }
        used[v] = true;
        for (auto &to: g[v]) {
            if (dist_s[to.first] > dist_s[v] + to.second) {
                dist_s[to.first] = dist_s[v] + to.second;
                ways_s[to.first] = ways_s[v];
                q.emplace(dist_s[to.first], to.first);
            } else if (dist_s[to.first] == dist_s[v] + to.second) {
                ways_s[to.first] = (ways_s[to.first] + ways_s[v]) % mod;
            }
        }
    }
    unordered_set<ll> a;
    for (auto &x: edges) {
        if (dist_s[x.u] + x.w + dist_t[x.v] == dist_s[t]) {
            a.insert(x.u);
            a.insert(x.v);
        }
    }
    a.erase(t);
    ll ans = 0;
    for (auto &u: a) {
        for (auto &to: g[u]) {
            ll v = to.first;
            ll w = to.second;

            if (dist_s[u] + w + dist_t[v] == L) {
                ans = (ans + ways_s[u] * ways_t[v]) % mod;
            }
        }
    }
    cout << ans % mod;
}