#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

#define MP make_pair

const int MOD = 1e9 + 7;

int n;

vector<pair<int, int>> g[200005];
vector<int> gt[200005];

bool used[200005];
void dfs(int v, vector<ll> &c){
    used[v] = true;
    for (int u : gt[v]){
        if (!used[u]) dfs(u, c);
        c[v] += c[u];
        c[v] %= MOD;
    }
}

void dijkstra(int st, vector<ll> &d, vector<ll> &c){
    for (int i = 0; i < n; i++){
        d[i] = 1e18;
        gt[i].clear();
    }

    d[st] = 0;
    priority_queue<pair<ll, int>> pq;
    pq.push(MP(0, st));

    vector<bool> processed(n);

    while (!pq.empty()){
        int x = pq.top().second;
        pq.pop();
        if (processed[x]) continue;
        processed[x] = true;
        for (auto [y, w] : g[x]){
            if (d[y] > d[x] + w){
                d[y] = d[x] + w;
                pq.push(MP(-d[y], y));
            }
        }
    }

    for (int v = 0; v < n; v++){
        for (auto [u, w] : g[v]){
            if (d[u] == d[v] + w){
                gt[u].push_back(v);
            }
        }
    }

    for (int i = 0; i < n; i++){
        c[i] = 0;
        used[i] = false;
    }

    c[st] = 1;
    for (int i = 0; i < n; i++){
        if (!used[i]) dfs(i, c);
    }
}

int main() {
    ios_base::sync_with_stdio(false);

    int m;
    cin >> n >> m;

    int x, y; ll L;
    cin >> x >> y >> L;

    --x, --y;

    for (int i = 1; i <= m; i++){
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }

    vector<ll> dx(n), dy(n);
    vector<ll> cx(n), cy(n);

    dijkstra(x, dx, cx);
    dijkstra(y, dy, cy);

    ll dist = dx[y];

    if (dist == L){
        cout << cx[y];
        return 0;
    }

    ll ans = 0;
    for (int v = 0; v < n; v++){
        if (dx[v] + dy[v] != dist) continue;

        for (auto [u, w] : g[v]){
            if (dx[v] + w + dy[u] == L && u != y){
                ans += cx[v] * cy[u] % MOD;
                ans %= MOD;
            }
        }

    }

    cout << ans << endl;

    return 0;
}
/*
6 6
1 6 6
1 2 1
2 3 1
2 4 1
3 5 1
4 5 1
5 6 1

 */