#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int N = 1005;

int n, m;

char a[N][N];

vector<int> dx = {0, 1, 0, -1, 1, 1, -1, -1};
vector<int> dy = {1, 0, -1, 0, 1, -1, 1, -1};

bool used[N][N];
bool lake;
vector<pair<int, int>> comp;

void dfs(int x, int y){
    used[x][y] = true;
    comp.emplace_back(x, y);
    if (x == 1 || y == 1 || x == n || y == m) lake = false;

    for (int l = 0; l < 4; l++){
        int i = x + dx[l], j = y + dy[l];
        if (i < 1 || i > n || j < 1 || j > m) continue;
        if (a[i][j] == '.' && !used[i][j]){
            dfs(i, j);
        }
    }
}

int mnx = n + 1, mny = m + 1, mxx = 0, mxy = 0;

bool f(int x, int y){
    return (mnx <= x && x <= mxx && mny <= y && y <= mxy);
}

int main() {
    ios_base::sync_with_stdio(false);

    cin >> n >> m;

    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            cin >> a[i][j];
        }
    }

    bool found = false;

    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            if (found) break;
            if (a[i][j] == '#') continue;
            if (!used[i][j]){
                lake = true;
                comp.clear();
                dfs(i, j);
                if (lake) found = true;
            }
        }
    }

    mnx = n + 1, mny = m + 1, mxx = 0, mxy = 0;
    for (auto [x, y] : comp){
        mnx = min(mnx, x);
        mny = min(mny, y);
        mxx = max(mxx, x);
        mxy = max(mxy, y);
    }

//    cout << mnx << ' ' << mny << ' ' << mxx << ' ' << mxy << endl;

    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            if (a[i][j] == '.') continue;
            bool ok = false;
            for (int l = 0; l < 8; l++){
                int x = i + dx[l], y = j + dy[l];
                if (f(x, y)) ok = true;
            }
            if (!ok) a[i][j] = '.';
        }
    }

    for (int i = mnx; i <= mxx; i++){
        for (int j = mny; j <= mxy; j++){
            a[i][j] = '.';
        }
    }

    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            cout << a[i][j];
        }
        cout << endl;
    }

    return 0;
}

/*
4 6
######
#.#.##
#...#.
#####.

 */