#include <bits/stdc++.h>
using namespace std;

void fastIO() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
}

const long long inf = 1e16, mod = 1e9 + 7;
const int N = 2e5 + 10;
vector<pair<long long, long long>> adj[N];
long long n, m, paths[N][2], dist[N][2];
long long s, t, l;
bool vis[N][2];

void dijik(int node, int state) {
  for(int i = 1; i <= n; i++) {
    dist[i][state] = inf;
    vis[i][state] = false;
  }

  dist[node][state] = 0;
  paths[node][state] = 1;
  
  priority_queue<pair<long long, long long>> q;
  q.push({0, node});
  while(!q.empty()) {
    auto u = q.top();
    q.pop();

    if(vis[u.second][state]) {
      continue;
    }
    vis[u.second][state] = true;

    for(auto i: adj[u.second]) {
      if(dist[u.second][state] + i.second < dist[i.first][state]) {
        dist[i.first][state] = dist[u.second][state] + i.second;
        paths[i.first][state] = paths[u.second][state];
        q.push({-dist[i.first][state], i.first});
      } else if((dist[u.second][state] + i.second) == dist[i.first][state]) {
        paths[i.first][state] += paths[u.second][state];
        paths[i.first][state] %= mod;
      }
    }
  }

  // cout << "dist" << endl;
  // for(int i = 1; i <= n; i++) {
  //   cout << dist[i][state] << " "; 
  // }
  // cout << endl;
  // cout << "path" << endl;
  // for(int i = 1; i <= n; i++) {
  //   cout << paths[i][state] << " "; 
  // }
  // cout << endl;
}


map<pair<pair<int, int>, long long>, bool> mp;

void solve() {
  cin >> n >> m;
  cin >> s >> t >> l;

  vector<pair<int, int>> edges;
  for(int i = 1; i <= m; i++) {
    long long a, b, c; cin >> a >> b >> c;
    adj[a].push_back({b, c});
    adj[b].push_back({a, c});
    edges.push_back({a, b});
  }

  dijik(s, 0);
  dijik(t, 1);

  long long min_dist = dist[t][0];

  if(l == min_dist) {
    cout << paths[t][0] << endl;
    return;
  }

  long long path = 0;
  for(int i = 1; i <= n; i++) {
    long long curr_dist = dist[i][0] + dist[i][1];
    if(curr_dist != min_dist) continue;

    for(auto j: adj[i]) {
      long long curr_dist = dist[i][0] + j.second + dist[j.first][1];
      
      if(mp[{{j.first, i}, curr_dist}]) {
        continue;
      }

      if(curr_dist == l) {
        path += (paths[i][0] * paths[j.first][1]) % mod;
        path %= mod;
      }
      mp[{{i, j.first}, curr_dist}] = true;
    }
  }

  cout << path << endl;
}

int main() {
  int test_cases = 1;
  // cin >> test_cases;

  while(test_cases--) {
    solve();
  }
  return 0;
}