#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <queue>
#include <time.h>
#include <bitset>
#include <unordered_map>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ft first
#define sc second
#define add push_back
#define all(v) v.begin(),v.end()
#define mpr make_pair
#define sz(v) (ll)v.size()
#define vi vector<int>
#define pii pair<int,int>
#define pll pair<ll,ll>
#define FOR(i,a,b) for(ll i = (a); i < (b); i++)
#define FORD(i,a,b) for(ll i = (a); i >= (b); i--)
#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

const ll MOD = 998244353;
const ll INF = 1e18;
const ll N = 1005;

//#define endl '\n'
char c[N][N];
bool color[N][N];
bool marked[N];
int comp = 1;
ll n,m;

bool check(int a, int b)
{
    if(a >= 1 and a <= n and b >= 1 and b <= m)
    {
        return true;
    }
    return false;
}

void dfs(int u, int v)
{
    color[u][v] = comp;
    if(u == 1 or v == 1 or u == n or v == m)
    {
        marked[comp] = 1;
    }
    if(check(u+1,v) and c[u+1][v] == '.' and color[u+1][v] != comp)
    {
        dfs(u+1,v);
    }
    if(check(u-1,v) and c[u-1][v] == '.' and color[u-1][v] != comp)
    {
        dfs(u-1,v);
    }
    if(check(u,v+1) and c[u][v+1] == '.' and color[u][v+1] != comp)
    {
        dfs(u,v+1);
    }
    if(check(u,v-1) and c[u][v-1] == '.' and color[u][v-1] != comp)
    {
        dfs(u,v-1);
    }
}

char tpel[N][N];

int main()
{

    fastio;

    
    cin>>n>>m;

    FOR(i,1,n+1)
    {
        FOR(j,1,m+1)
        {
            cin>>c[i][j];
        }
    }
    ll col = 0;
    FOR(i,1,n+1)
    {
        FOR(j,1,m+1)
        {
            if(c[i][j] == '.' and color[i][j] == 0)
            {
                dfs(i,j);
                if(marked[comp] == 0)
                {
                    col = comp;
                    break;
                }
                comp++;
            }
        }
        if(col != 0)
        {
            break;
        }
    }
    
    ll i1 = 0,j1 = 0,i2 = 0,j2,i3 = 0,j3,i4 = 0,j4;
    FOR(i,1,n+1)
    {
        FOR(j,1,m+1)
        {
            if(color[i][j] == col and c[i][j] == '.')
            {
                i1 = i; j1 = j;
                break;
            }
        }
        if(i1 != 0)
        {
            break;
        }
    }
    FORD(i,n,1)
    {
        FOR(j,1,m+1)
        {
            if(color[i][j] == col and c[i][j] == '.')
            {
                i2 = i; j2 = j;
                break;
            }
        }
        if(i2 != 0)
        {
            break;
        }
    }
    FORD(i,n,1)
    {
        FORD(j,m,1)
        {
            if(color[i][j] == col and c[i][j] == '.')
            {
                i3 = i; j3 = j;
                break;
            }
        }
        if(i3 != 0)
        {
            break;
        }
    }
    FOR(i,1,n+1)
    {
        FORD(j,m,1)
        {
            if(color[i][j] == col and c[i][j] == '.')
            {
                i4 = i; j4 = j;
                break;
            }
        }
        if(i4 != 0)
        {
            break;
        }
    }

    ll i = i1-1, j = j1-1;
    tpel[i][j] = '#';
    while(i <=  i2)
    {
        if(c[i+1][j] == '#')
        {
            i++;
            tpel[i][j] = '#';
        }
        else if(c[i][j+1] == '#')
        {
            j++;
            tpel[i][j] = '#';
        }
        else
        {
            j--;
            tpel[i][j] = '#';
        }
    }
    
    while(j <=  j3)
    {
        if(c[i][j+1] == '#')
        {
            j++;
            tpel[i][j] = '#';
        }
        else if(c[i-1][j] == '#')
        {
            i--;
            tpel[i][j] = '#';
        }
        else
        {
            i++;
            tpel[i][j] = '#';
        }
    }
    while(i >= i4)
    {
        if(c[i-1][j] == '#')
        {
            i--;
            tpel[i][j] = '#';
        }
        else if(c[i][j-1] == '#')
        {
            j--;
            tpel[i][j] = '#';
        }
        else
        {
            j++;
            tpel[i][j] = '#';
        }
    }
    while(j >= j1)
    {
        if(c[i][j-1] == '#')
        {
            j--;
            tpel[i][j] = '#';
        }
        else if(c[i+1][j] == '#')
        {
            i++;
            tpel[i][j] = '#';
        }
        else
        {
            i--;
            tpel[i][j] = '#';
        }
    }
    FOR(i,1,n+1)
    {
        FOR(j,1,m+1)
        {
            if(tpel[i][j] == '#')
            {
                cout<<'#';
            }
            else
            {
                cout<<'.';
            }
        }
        cout<<endl;
    }


    return 0;
}