#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;

template<typename T>
bool rmax(T& a, T b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
bool rmin(T& a, T b) {
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T>& a) {
    for (auto &it : a) {
        in << it << ' ';
    }
    return in;
}

const int INF = 1e9 + 7;
int add(int a, int b) {
    int c = (a + b) % INF;
    if (c < 0) {
        c += INF;
    }
    return c;
}

int mul(int a, int b) {
    int c = (a * b) % INF;
    if (c < 0) {
        c += INF;
    }
    return c;
}

const int MAXN = 2e5 + 1;
vector<pii> adj[MAXN];
bool used[MAXN];
vector<int> dag_from_start[MAXN];
vector<int> dag_from_end[MAXN];
int cnt_in_first_dag[MAXN];
int cnt_in_second_dag[MAXN];
int dist_from_start[MAXN];
int dist_from_end[MAXN];

void dijkstra(int st, int type) {
    fill(used, used + MAXN, 0);
    if (type == 1)
        dist_from_start[st] = 0;
    else
        dist_from_end[st] = 0;

    priority_queue<pii> q;
    q.push({0, st});

    while (!q.empty()) {
        int v = q.top().Y;
        q.pop();

        if (used[v]) {
            continue;
        }

        used[v] = 1;

        for (auto &it : adj[v]) {
            if (!used[it.X]) {
                if (type == 1) {
                    if (rmin(dist_from_start[it.X], dist_from_start[v] + it.Y)) {
                        q.push({-dist_from_start[it.X], it.X});
                    }
                } else {
                    if (rmin(dist_from_end[it.X], dist_from_end[v] + it.Y)) {
                        q.push({-dist_from_end[it.X], it.X});
                    }
                }
            }
        }
    }

    for (int i = 0; i < MAXN; i++) {
        for (auto it : adj[i]) {
            if (type == 1) {
                if (dist_from_start[i] + it.Y == dist_from_start[it.X]) {
                    dag_from_start[it.X].push_back(i);
//                    cout << it.X << ' ' << i << endl;
                }
            } else {
                if (dist_from_end[i] + it.Y == dist_from_end[it.X]) {
                    dag_from_end[it.X].push_back(i);
//                    cout << it.X << ' ' << i << endl;
                }
            }
        }
    }
}

bool dfs(int v, int en, int type) {
    if (v == en) {
        used[v] = 1;
        if (type == 1) {
            cnt_in_first_dag[v] = 1;
        } else {
            cnt_in_second_dag[v] = 1;
        }

        return 1;
    }

    used[v] = 1;
    bool has = 0;
    if (type == 1) {
        cnt_in_first_dag[v] = 0;
    } else {
        cnt_in_second_dag[v] = 0;
    }

    if (type == 1) {
        for (auto &it: dag_from_start[v]) {
            if (!used[it]) {
                if (dfs(it, en, type)) {
                    has = 1;
                    cnt_in_first_dag[v] = add(cnt_in_first_dag[v], cnt_in_first_dag[it]);
                }
            }
        }
    } else {
        for (auto &it: dag_from_end[v]) {
            if (!used[it]) {
                if (dfs(it, en, type)) {
                    has = 1;
                    cnt_in_second_dag[v] = add(cnt_in_second_dag[v], cnt_in_second_dag[it]);
                }
            }
        }
    }

    return has;
}

void calc_first(int s, int t) {
    dijkstra(s, 1);
    fill(used, used + MAXN, 0);
    dfs(t, s, 1);

    dijkstra(t, 0);
    fill(used, used + MAXN, 0);
    dfs(s, t, 0);
}

int MOD = 1e9 + 7;

struct Integer {
    int i;
};

Integer operator + (Integer a, Integer b) {
    a.i = add(a.i, b.i);
    return a;
}

Integer operator - (Integer a, Integer b) {
    a.i = add(a.i, -b.i);
    return a;
}

Integer operator * (Integer a, Integer b) {
    a.i = mul(a.i, b.i);
    return a;
}

Integer operator * (Integer a, int b) {
    a.i = mul(a.i, b);
    return a;
}

void do_even(vector<vector<pii> >& g_to, vector<vector<pii> >& g_fr, int n, int m){
    if(n % 2 == 0){
        g_to[0][0] = {0, 1};
        g_fr[0][1] = {0, 0};
        for(int i = 0; i < n; i += 2){
            for(int j = 1; j < m - 1; j++){
                g_to[i][j] = {i, j + 1};
                g_fr[i][j + 1] = {i, j};
            }
            g_to[i][m - 1] = {i + 1, m - 1};
            g_fr[i + 1][ m - 1] = {i, m - 1};
        }
        for(int i = 1; i < n; i += 2){
            for(int j = 2; j < m; j++){
                g_to[i][j] = {i, j - 1};
                g_fr[i][j - 1] = {i, j};
            }
            if(i != n - 1) g_to[i][1] = {i + 1, 1};
            if(i != n - 1) g_fr[i + 1][1] = {i, 1};
        }
        g_to[n - 1][1] = {n - 1, 0};
        g_fr[n - 1][0] = {n - 1, 1};
        for(int i = n - 1; i > 0; i--){
            g_to[i][0] = {i - 1, 0};
            g_fr[i - 1][0] = {i, 0};
        }
    }
    else{
        g_to[0][0] = {1, 0};
        g_fr[1][0] = {0, 0};
        for(int i = 0; i < m; i += 2){
            for(int j = 1; j < n - 1; j++){
                g_to[j][i] = {j + 1, i};
                g_fr[j + 1][i] = {j, i};
            }
            g_to[n - 1][i] = {n - 1, i + 1};
            g_fr[n - 1][ i + 1] = {n - 1, i};
        }
        for(int i = 1; i < m; i += 2){
            for(int j = 2; j < n; j++){
                g_to[j][i] = {j - 1, i};
                g_fr[j - 1][i] = {j, i};
            }
            if(i != m - 1) g_to[1][i] = {1, i + 1};
            if(i != m - 1) g_fr[1][i + 1] = {1, i};
        }
        g_to[1][n - 1] = {0, n - 1};
        g_fr[0][n - 1] = {1, n - 1};
        for(int i = m - 1; i > 0; i--){
            g_to[0][i] = {0, i - 1};
            g_fr[0][i - 1] = {0, i};
        }
    }
}

void do_odd(vector<vector<pii> >& g_to, vector<vector<pii> >& g_fr, int n, int m){
    g_to[0][m - 2] = {0, m - 3};
    g_fr[0][m - 3] = {0, m - 2};
    for(int j = m - 3; j >= 0; j--){
        if(j % 2 == 0){
            for(int i = 0; i < n - 2; i++){
                g_to[i][j] = {i + 1, j};
                g_fr[i + 1][j] = {i, j};
            }
            if(j > 0){
                g_to[n - 2][j] = {n - 2, j - 1};
                g_fr[n - 2][j - 1] = {n - 2, j};
            }
        }
        else{
            for(int i = 1; i < n - 1; i++){
                g_to[i][j] = {i - 1, j};
                g_fr[i - 1][j] = {i, j};
            }
            g_to[0][j] = {0, j - 1};
            g_fr[0][j - 1] = {0, j};
        }
    }
    g_to[n - 2][0] = {n - 1, 0};
    g_fr[n - 1][0] = {n - 2, 0};
    for(int j = 0; j < m - 1; j++){
        g_to[n-1][j] = {n-1, j+1};
        g_fr[n-1][j+1] = {n-1, j};
    }
    for(int i = n - 1; i > 1; i--) {
        if (i % 2 == 0){
            g_to[i][m - 1] = {i - 1, m - 1};
            g_fr[i - 1][m - 1] = {i, m - 1};
            g_to[i - 1][m - 1] = {i - 1, m - 2};
            g_fr[i - 1][m - 2] = {i - 1, m - 1};
        }
        else{
            g_to[i][m - 2] = {i - 1, m - 2};
            g_fr[i - 1][m - 2] = {i, m - 2};
            g_to[i - 1][m - 2] = {i - 1, m - 1};
            g_fr[i - 1][m - 1] = {i - 1, m - 2};
        }
    }
    g_to[1][m - 2] = {0, m - 2};
    g_fr[0][m - 2] = {1, m - 2};
}

void solve() {
    int n, m, stx, sty, enx, eny;
    cin >> n >> m >> stx >> sty >> enx >> eny;
    vector<vector<int> > cost(n, vector<int> (m));
//    cin >> cost;

    vector<vector<pii> > g_to(n, vector<pii>(m));
    vector<vector<pii> > g_fr(n, vector<pii>(m));
    if(n * m % 2 == 0){
        do_even(g_to, g_fr, n, m);
    }
    else{
        do_odd(g_to, g_fr, n, m);
    }

    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            cout << g_to[i][j].X << ' ' << g_to[i][j].Y << "   ";
        }
        cout << endl;
    }

}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("..\\input.txt", "r", stdin);
    freopen("..\\output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}