#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <string>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;
typedef long long ll;
typedef long double ld;
const long long INF = 1e18;
const int32_t MAXN = 2E5;
const int64_t MOD = 1E9 + 7;

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	int ans;
	Mod_int(const int64_t& ans = 0) :ans(ans% MOD) {}
	Mod_int operator+(const Mod_int& x) const
	{
		return ans + x.ans;
	}
	Mod_int operator+=(const Mod_int& x)
	{
		return *this = *this + x;
	}
	Mod_int operator* (const Mod_int& x) const
	{
		return int64_t(ans) * x.ans;
	}
	Mod_int operator*=(const Mod_int& x)
	{
		return *this = *this * x;
	}
};

int64_t dist_t[MAXN], dist_s[MAXN];
Mod_int sp_t[MAXN], sp_s[MAXN];
vector <pair <int, int64_t>> mas[MAXN];
Mod_int cnt[MAXN];
int64_t l;
int s, t;

Mod_int get_ans(int x)
{
	if (cnt[x].ans != -1)
	{
		return cnt[x];
	}
	Mod_int ans = 0;
	if (x == t)
	{
		return cnt[x] = int(l == dist_t[s]);
	}
	for (int i = 0; i < mas[x].size(); i++)
	{
		int next = mas[x][i].first;
		int64_t w = mas[x][i].second;
		if (dist_t[next] + w == dist_t[x])
		{
			ans += get_ans(next);
		}
		else if (dist_t[next] + w == l - dist_s[x])
		{
			ans += sp_t[next];
		}
	}
	return cnt[x] = ans;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	fill(dist_t, dist_t + MAXN, 1E18);
	fill(dist_s, dist_s + MAXN, 1E18);
	fill(cnt, cnt + MAXN, -1);

	int n, m;
	cin >> n >> m;
	cin >> s >> t >> l;
	--s;
	--t;
	for (int i = 0; i < m; i++)
	{
		int x, y;
		int64_t z;
		cin >> x >> y >> z;
		mas[x - 1].push_back({ y - 1,z });
		mas[y - 1].push_back({ x - 1,z });
	}
	set <pair <int64_t, int>> mp;
	dist_t[t] = 0;
	sp_t[t] = 1;
	mp.insert({ 0,t });
	while (!mp.empty())
	{
		auto p = *mp.begin();
		mp.erase(mp.begin());
		for (int i = 0; i < mas[p.second].size(); i++)
		{
			int next = mas[p.second][i].first;
			int64_t w = mas[p.second][i].second;
			if (dist_t[next] > dist_t[p.second] + w)
			{
				if (dist_t[next] != 1E18)
				{
					mp.erase({ dist_t[next],next });
				}
				dist_t[next] = dist_t[p.second] + w;
				mp.insert({ dist_t[next], next });
				sp_t[next] = sp_t[p.second];
			}
			else if (dist_t[next] == dist_t[p.second] + w)
			{
				sp_t[next] += sp_t[p.second];
			}
		}
	}

	dist_s[s] = 0;
	sp_s[s] = 1;
	mp.insert({ 0,s });
	while (!mp.empty())
	{
		auto p = *mp.begin();
		mp.erase(mp.begin());
		for (int i = 0; i < mas[p.second].size(); i++)
		{
			int next = mas[p.second][i].first;
			int64_t w = mas[p.second][i].second;
			if (dist_s[next] > dist_s[p.second] + w)
			{
				if (dist_s[next] != 1E18)
				{
					mp.erase({ dist_s[next],next });
				}
				dist_s[next] = dist_s[p.second] + w;
				mp.insert({ dist_s[next], next });
				sp_s[next] = sp_s[p.second];
			}
			else if (dist_s[next] == dist_s[p.second] + w)
			{
				sp_s[next] += sp_s[p.second];
			}
		}
	}

	cout << get_ans(s).ans;
}