#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
//#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const ld EPS = 1e-9;

vector<vector<char>> f;
vector<vector<bool>> was;
vector<vector<char>> ans;
int n, m;

void obhod(int i, int j) {
    if (was[i][j] || f[i][j] != '.') return;
    was[i][j] = true;
    queue<pair<int, int>> q;
    q.push({i, j});
    while (!q.empty()) {
        auto [x, y] = q.front();
        q.pop();
        if (x > 0 && !was[x - 1][y] && f[x - 1][y] == '.') {
            was[x - 1][y] = true;
            q.push({x - 1, y});
        }
        if (x < n - 1 && !was[x + 1][y] && f[x + 1][y] == '.') {
            was[x + 1][y] = true;
            q.push({x + 1, y});
        }
        if (y > 0 && !was[x][y - 1] && f[x][y - 1] == '.') {
            was[x][y - 1] = true;
            q.push({x, y - 1});
        }
        if (y < m - 1 && !was[x][y + 1] && f[x][y + 1] == '.') {
            was[x][y + 1] = true;
            q.push({x, y + 1});
        }
    }
}

void bfs(pair<int, int> s, pair<int, int> t, int lx, int rx, int ly, int ry) {
    vector<vector<int>> d(n, vector<int> (m, INF));
    vector<vector<pair<int, int>>> p(n, vector<pair<int, int>> (m, {-1, -1}));
    d[s.first][s.second] = 0;
    queue<pair<int, int>> q;
    q.push(s);
    while (!q.empty()) {
        auto [x, y] = q.front();
        q.pop();
        if (x < lx || y < ly || x > rx || y > ry) continue;
        if (x > 0 && d[x - 1][y] == INF && f[x - 1][y] == '#') {
            d[x - 1][y] = d[x][y] + 1;
            p[x - 1][y] = {x, y};
            q.push({x - 1, y});
        }
        if (x < n - 1 && d[x + 1][y] == INF && f[x + 1][y] == '#') {
            d[x + 1][y] = d[x][y] + 1;
            p[x + 1][y] = {x, y};
            q.push({x + 1, y});
        }
        if (y > 0 && d[x][y - 1] == INF && f[x][y - 1] == '#') {
            d[x][y - 1] = d[x][y] + 1;
            p[x][y - 1] = {x, y};
            q.push({x, y - 1});
        }
        if (y < m - 1 && d[x][y + 1] == INF && f[x][y + 1] == '#') {
            d[x][y + 1] = d[x][y] + 1;
            p[x][y + 1] = {x, y};
            q.push({x, y + 1});
        }
    }
    while (t.first != -1) {
        ans[t.first][t.second] = '#';
        t = p[t.first][t.second];
    }
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    cin >> n >> m;
    f.assign(n, vector<char> (m));
    for (auto &i : f) {
        for (auto &j : i) cin >> j;
    }
    was.assign(n, vector<bool> (m));
    for (int i = 0; i < n; i++) {
       obhod(i, 0);
       obhod(i, m - 1);
    }
    for (int j = 0; j < m; j++) {
        obhod(0, j);
        obhod(n - 1, j);
    }
    pair<int, int> lef = {INF, INF}, rig = {0, 0}, up = {INF, INF}, down = {0, 0};
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (was[i][j] || f[i][j] == '#') continue;
            if (i < up.first || (i == up.first && j < up.second)) up = {i, j};
            if (i > down.first || (i == down.first && j > down.second)) down = {i, j};
            if (j < lef.second || (j == lef.second && i > lef.first)) lef = {i, j};
            if (j > rig.second || (j == rig.second && i < rig.first)) rig = {i, j};
        }
    }
    up.first--; down.first++; lef.second--; rig.second++;
    ans.assign(n, vector<char> (m, '.'));
    bfs(up, lef, 0, down.first - 1, 0, rig.second - 1);
    bfs(lef, down, up.first + 1, n - 1, 0, rig.second - 1);
    bfs(down, rig, up.first + 1, n - 1, lef.second + 1, m - 1);
    bfs(rig, up, 0, down.first - 1, lef.second + 1, m - 1);
    for (auto &i : ans) {
        for (auto j : i) cout << j;
        cout << '\n';
    }
}
