#include <bits/stdc++.h>

using namespace std;
#define int long long
#define double long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define ff first
#define ss second
using pii = pair <int, int>;

template <typename T>
void mxr(T& a, const T& b) {
    a = max(a, b);
}
template <typename T>
void mnr(T& a, const T& b) {
    a = min(a, b);
}

template <typename T>
istream& operator>>(istream& is, vector<T>& v) {
    for (auto& i : v) {
        is >> i;
    }
    return is;
};

template <typename T>
ostream & operator<<(ostream& is, const vector<T>& v) {
    for (const auto& i : v) {
        is << i << " ";
    }
    return is;
};

class Fenwick {
private:
    vector <int> data;

    int get(int r) {
        int ans = 0;
        for(--r; r >= 0; r = (r & (r + 1)) - 1) {
            ans += data[r];
        }
        return ans;
    }

public:
    Fenwick(int sz) {
        data.assign(sz, 0);
    }

    void update(int pos, int val) {
        for(; pos < data.size(); pos |= pos + 1) {
            data[pos] += val;
        }
    }

    int get(int l, int r) {
        return get(r) - get(l);
    }
};

using t3 = tuple<int, int, int>;

const int INF = 1e15 + 3;

vector <int> dist(const vector <vector <pii> >& g, int start) {
    int n = sz(g);
    set <pii> st;
    vector <int> res(n, INF);
    res[start] = 0;
    st.insert({0ll, start});
    while (!st.empty()) {
        auto c = st.begin()->second;
        st.erase(st.begin());
        for (auto [to, w] : g[c]) {
            if (res[to] > res[c] + w) {
                st.erase({res[to], to});
                res[to] = res[c] + w;
                st.insert({res[to], to});
            }
        }
    }
    return res;
}

const int MOD = 1e9 + 7;

void dfs(int c, vector <int>& ord, vector <bool>& used, const vector <vector <int> >& g) {
    used[c] = true;
    for (auto to : g[c]) {
        if (!used[to]) {
            dfs(to, ord, used, g);
        }
    }
    ord.push_back(c);
}

vector <int> vars(const vector <vector <int> >& g, int start) {
    vector <int> ord;
    int n = sz(g);
    vector <bool> used(n);
    dfs(start, ord, used, g);
    reverse(all(ord));
    vector <int> dp(n);
    dp[start] = 1;
    for (auto i : ord) {
        for (auto j : g[i]) {
            dp[j] += dp[i];
            dp[j] %= MOD;
        }
    }
    return dp;
}

signed main() {
//#ifdef SYSTY257
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(15) << fixed;

    int n, m;
    cin >> n >> m;
    int s, t, L;
    cin >> s >> t >> L;
    --s, --t;
    vector <vector <pii> > g(n);
    vector <t3> edges;
    for (int i = 0; i < m; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        --a, --b;
        edges.emplace_back(a, b, w);
        edges.emplace_back(b, a, w);
        g[a].emplace_back(b, w);
        g[b].emplace_back(a, w);
    }
    auto d1 = dist(g, s);
    auto d2 = dist(g, t);
    int opt = d1[t];
//    cerr << d1 << "\n" << d2 << "\n\n";
    vector <vector <int> > g1(n), g2(n);
    for (auto [a, b, w] : edges) {
        if (d1[a] + w + d2[b] == opt) {
            g1[a].push_back(b);
        }
        if (d2[a] + w == d2[b]) {
            g2[a].push_back(b);
        }
    }
    auto vars1 = vars(g1, s);
    auto vars2 = vars(g2, t);
//    for (int i = 0; i < n; ++i) {
//        cout << i << ": " << g1[i] << "\n";
//    }
//    for (int i = 0; i < n; ++i) {
//        cout << i << ": " << g2[i] << "\n";
//    }
    int res = 0;
//    cerr << vars1 << "\n" << vars2 << "\n";
    for (auto [a, b, w] : edges) {
        if (a == t) {
            continue;
        }
        if (d1[a] + d2[b] + w == L) {
//            cerr << a << " " << b << " " << vars1[a] * vars2[b] << "\n";
            res += vars1[a] * vars2[b] % MOD;
            res %= MOD;
        }
    }
    cout << res;
}