#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define double long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define ff first
#define ss second
using pii = pair<int, int>;

template<typename T>
void mxr(T &a, const T &b) {
    a = max(a, b);
}

template<typename T>
void mnr(T &a, const T &b) {
    a = min(a, b);
}

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &i: v) {
        is >> i;
    }
    return is;
};

template<typename T>
ostream &operator<<(ostream &is, const vector<T> &v) {
    for (const auto &i: v) {
        is << i << " ";
    }
    return is;
};

class Fenwick {
private:
    vector<int> data;

    int get(int r) {
        int ans = 0;
        for (--r; r >= 0; r = (r & (r + 1)) - 1) {
            ans += data[r];
        }
        return ans;
    }

public:
    Fenwick(int sz) {
        data.assign(sz, 0);
    }

    void update(int pos, int val) {
        for (; pos < data.size(); pos |= pos + 1) {
            data[pos] += val;
        }
    }

    int get(int l, int r) {
        return get(r) - get(l);
    }
};

using t3 = tuple<int, int, int>;

const int INF = 1e15 + 3;

vector<int> dist(const vector<vector<pii> > &g, int start) {
    int n = sz(g);
    set<pii> st;
    vector<int> res(n, INF);
    res[start] = 0;
    st.insert({0ll, start});
    while (!st.empty()) {
        auto c = st.begin()->second;
        st.erase(st.begin());
        for (auto [to, w]: g[c]) {
            if (res[to] > res[c] + w) {
                st.erase({res[to], to});
                res[to] = res[c] + w;
                st.insert({res[to], to});
            }
        }
    }
    return res;
}

const int MOD = 1e9 + 7;

void dfs(int c, vector<int> &ord, vector<bool> &used, const vector<vector<int> > &g) {
    used[c] = true;
    for (auto to: g[c]) {
        if (!used[to]) {
            dfs(to, ord, used, g);
        }
    }
    ord.push_back(c);
}

vector<int> vars(const vector<vector<int> > &g, int start) {
    vector<int> ord;
    int n = sz(g);
    vector<bool> used(n);
    dfs(start, ord, used, g);
    reverse(all(ord));
    vector<int> dp(n);
    dp[start] = 1;
    for (auto i: ord) {
        for (auto j: g[i]) {
            dp[j] += dp[i];
            dp[j] %= MOD;
        }
    }
    return dp;
}

struct Vec {
    int x{}, y{};

    Vec(int x, int y) : x(x), y(y) {}

    Vec() = default;

    Vec(Vec a, Vec b) : x(b.x - a.x), y(b.y - a.y) {}

    int operator%(const Vec &other) const {
        return x * other.y - y * other.x;
    }

    bool operator<(const Vec &other) const {
        return make_pair(x, y) < make_pair(other.x, other.y);
    }
};

int lensq(Vec a) {
    return a.x * a.x + a.y * a.y;
}

int sq(Vec a, Vec b, Vec c) {
    return abs(Vec(a, b) % Vec(a, c));
}

bool isInTriangle(Vec a, Vec b, Vec c, Vec p) {
    return sq(a, b, p) + sq(b, c, p) + sq(c, a, p) == sq(a, b, c);
}

bool isIn(const vector<Vec> &p, Vec a) {
    int n = sz(p);
    int l = 1, r = n - 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (Vec(p[0], a) % Vec(p[0], p[m]) <= 0) {
            l = m;
        } else {
            r = m;
        }
    }
    if (isInTriangle(p[0], p[l], p[l + 1], a)) {
        return true;
    } else {
        return false;
    }
}
vector<pii> moves = {
        {-1, 0},
        {0,  -1},
        {1,  0},
        {0,  1}
};

signed main() {
//#ifdef SYSTY257
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(15) << fixed;

    int n, m;
    cin >> n >> m;
    vector<string> v(n);
    cin >> v;
    vector<vector<int> > used(n, vector<int>(m, 0));
    vector<vector<int> > comp(n, vector<int>(m, 9));
    int compid = 0;
    function<void(int, int)> dfs = [&](int i, int j) {
        used[i][j] = 1;
        for (auto [a, b] : moves) {
            int dx = i + a, dy = j + b;
            if (dx >= 0 && dx < n && dy >= 0 && dy < m) {if (dx >= 0 && dx < n && dy >= 0 && dy < m) {
                    if (!used[dx][dy] && v[dx][dy] == '.') {
                        comp[dx][dy] = comp[i][j];
                        dfs(dx, dy);
                    }
                }
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!used[i][j] && v[i][j] == '.') {
                comp[i][j] = compid++;
                dfs(i, j);
            }
        }
    }
    vector<bool> good(compid, true);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (v[i][j] == '#') {
                continue;
            }
            for (int dx = i - 1; dx <= i + 1; ++dx) {
                for (int dy = j - 1; dy <= j + 1; ++dy) {if (dx == i && dy == j) {
                        continue;
                    }
                    if (!(dx >= 0 && dx < n && dy >= 0 && dy < m)) {
                        good[comp[i][j]] = false;
                    }
                }
            }
        }
    }
    vector<Vec> cells;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (v[i][j] == '.' && good[comp[i][j]]) {
                cells.emplace_back(i, j);
            }
        }
    }
    vector<vector<bool> > bad(n, vector<bool>(m));
    vector<vector<int> > cnt(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int dx = i - 1; dx <= i + 1; ++dx) {
                for (int dy = j - 1; dy <= j + 1; ++dy) {
                    if (dx == i && dy == j) {
                        continue;
                    }
                    if (dx >= 0 && dx < n && dy >= 0 && dy < m) {
                        if (v[dx][dy] == '.' && !good[comp[dx][dy]]) {
                            bad[i][j] = true;
                        }
                    }
                }
            }
//            for (int dx = i - 1; dx <= i + 1; ++dx) {
//                for (int dy = j - 1; dy <= j + 1; ++dy) {
//                    if (dx >= 0 && dx < n && dy >= 0 && dy < m) {
//                        if (v[dx][dy] == '.' && good[comp[dx][dy]]) {
//                            ++cnt[i][j];
//                        }
//                    }
//                }
//            }
        }
    }

    queue<pii> q;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (v[i][j] == '#') {
                q.push({i, j});
            }
        }
    }
    vector<vector<int> > t(n, vector<int>(m));
    vector<string> bt = v;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (v[i][j] == '.' && !good[comp[i][j]]) {
                bt[i][j] = '%';
            }
        }
    }
    auto isbad = [&](int i, int j) {
        if (bad[i][j]) {
            return false;
        }
        int cnt = 0;
        for (auto [a, b] : moves) {
            int dx = i + a, dy = j + b;
                if (dx >= 0 && dx < n && dy >= 0 && dy < m) {
                    if (bt[dx][dy] == '.') {
                        ++cnt;
                    }
                } else {
                    return false;
                }
            }
        return cnt > 1;
    };
    while (!q.empty()) {
        auto [i, j] = q.front();
        q.pop();
        if (bt[i][j] == '#' && isbad(i, j)) {
            bt[i][j] = '.';
            for (auto [a, b]: moves) {
                int dx = i + a, dy = j + b;
                if (dx >= 0 && dx < n && dy >= 0 && dy < m) {
                    if (bt[dx][dy] == '#') {
                        q.push({dx, dy});
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (bt[i][j] != '#') {
                continue;
            }
            for (int dx = i - 1; dx <= i + 1; ++dx) {
                for (int dy = j - 1; dy <= j + 1; ++dy) {
                    if (dx == i && dy == j) {
                        continue;
                    }
                    if (dx >= 0 && dx < n && dy >= 0 && dy < m) {
                        if (bt[dx][dy] == '.') {
                            t[i][j] = true;
                        }
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (t[i][j]) {
                cout << '#';
            } else {
                cout << '.';
            }
        }
        cout << "\n";
    }
}