#include <set>
#include <iostream>
#include <vector>
using namespace std;

#define int long long

constexpr int32_t mod = 1e9 + 7;
int n;
vector<vector<pair<int, int>>> g;
vector<vector<pair<int, int>>> g1, g2;
vector<int> cnt1, cnt2;
void dj(int s, vector<int>& dist) {
	dist.assign(n, 1e18);
	set<pair<int, int>> st = { { 0, s } };
	dist[s] = 0;
	while (!st.empty()) {
		int v = (*st.begin()).second;
		st.erase(st.begin());
		for (auto j : g[v]) {
			if (dist[j.first] > dist[v] + j.second) {
				st.erase({ dist[j.first], j.first });
				dist[j.first] = dist[v] + j.second;
				st.insert({  dist[j.first], j.first });
			}
		}
	}
}

void dfs1(int i) {
	cnt1[i] = 0;
	for (auto j : g1[i]) {
		if (cnt1[j.first] == -1) dfs1(j.first);
		cnt1[i] += cnt1[j.first];
	}

	cnt1[i] = cnt1[i] % mod;
}

void dfs2(int i) {
	cnt2[i] = 0;
	for (auto j : g2[i]) {
		if (cnt2[j.first] == -1) dfs2(j.first);
		cnt2[i] += cnt2[j.first];
	}

	cnt2[i] = cnt2[i] % mod;
}

int32_t main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	int m;
	cin >> n >> m;

	int s, t, L;
	cin >> s >> t >> L;
	s--; t--;

	g.assign(n, {});
	cnt1.assign(n, -1);
	cnt2.assign(n, -1);
	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		a--; b--;

		g[a].push_back({ b, c });
		g[b].push_back({ a, c });
	}

	vector<int> dist1, dist2;
	dj(s, dist1);
	dj(t, dist2);
	g1.assign(n, vector<pair<int, int>>{});
	g2.assign(n, vector<pair<int, int>>{});
	for (int i = 0; i < n; i++) {
		for (auto j : g[i]) {
			if (dist1[i] + j.second == dist1[j.first]) {
				g1[j.first].push_back({ i, j.second });
			}

			if (dist2[i] + j.second == dist2[j.first]) {
				g2[j.first].push_back({ i, j.second });
			}
		}
	}

	cnt1[s] = 1;
	dfs1(t);

	cnt2[t] = 1;
	for (int i = 0; i < n; i++) {
		if (cnt2[i] == -1) dfs2(i);
	}

	long long ans = 0;
	for (int i = 0; i < n; i++) {
		if (cnt1[i] == -1) cnt1[i] = 0;
		for (auto j : g[i]) {
			if ((dist1[i] + j.second != dist1[j.first] || cnt1[j.first] <= 0) && dist1[i] + j.second + dist2[j.first] == L) {
				ans += (1ll * cnt1[i] * cnt2[j.first]) % mod;
			}
		}
	}

	cout << (ans + (dist1[t] == L ? cnt1[t] : 0)) % mod << endl;
}
/*
6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4
*/