//
// Created by orspc on 05.12.2022.
//
#include <bits/stdc++.h>

using namespace std;

int intersect(const vector<int> &a, const vector<int> &b) {
    set<int> s(b.begin(), b.end());
    for (int i : a) {
        if (s.find(i) != s.end()) {
            return i;
        }
    }
    return -1;
}



int main() {
    int n; cin >> n;
    vector<vector<int>> partition = {{}};
    vector<int> horiz_num(n + 1), vert_num(n + 1);
    vector<vector<int>> vert_groups(n + 1);
    vector<int> ans(n + 1, -1);
    for (int i = 1; i <= n; i++) {
        if (partition.size() == partition.back().size()) {
            partition.push_back({});
        }
        partition.back().push_back(i);
        horiz_num[i] = partition.size();
    }
    bool has_undef = (partition.back().size() != partition.size());
    int mx_vert_num = 0;
    for (vector<int> &part : partition) {
        for (int i = 0; i < (int) part.size(); i++) {
            vert_groups[i + 1].push_back(part[i]);
            vert_num[part[i]] = i + 1;
            mx_vert_num = max(mx_vert_num, i + 1);
        }
    }
    vector<int> inverse_vert_group_sizes(n + 1);
    for (int i = 0; i <= n; i++) {
        inverse_vert_group_sizes[vert_groups[i].size()] = i;
    }
    int undefined_size = partition.back().size();
    if (!has_undef) {
        undefined_size = 0;
    }
    vector<int> undef_first, undef_second;
    cout << partition.size() << endl;

    vector<vector<int>> partition_result(partition.size());
    for (int i = 1; i <= n; i++) {
        cout << horiz_num[i] << ' ';
    }
    cout << endl;
    for (int i = 0; i < partition.size(); i++) {
        int t; cin >> t;
        for (int j = 0; j < t; j++) {
            int x; cin >> x;
            if (t != undefined_size) {
                partition_result[t - 1].push_back(x);
            }
        }
    }
    cout << mx_vert_num << endl;
    for (int i = 1; i <= n; i++) {
        cout << vert_num[i] << ' ';
    }
    cout << endl;

    vector<vector<int>> vert_result(n + 1);
    for (int g = 0; g < mx_vert_num; g++) {
        int sz; cin >> sz;
        for (int i = 0; i < sz; i++) {
            int x; cin >> x;
            vert_result[inverse_vert_group_sizes[sz]].push_back(x);
        }
    }

//    for (auto v : partition_result) {
//        for (int i : v) {
//            cout << i << ' ';
//        }
//        cout << endl;
//    }
//
//    for (auto v : vert_result) {
//        for (int i : v) {
//            cout << i << ' ';
//        }
//        cout << endl;
//    }

    for (int p = 0; p < (int) partition.size(); p++) {
        const vector<int> &part = partition[p];
        for (int i : part) {
            if (part.size() != undefined_size) {
                ans[i] = intersect(partition_result[p], vert_result[vert_num[i]]);
            }
        }
    }

    vector<int> known_answer(n + 1);
    for (int i = 1; i <= n; i++) {
        if (ans[i] != -1) {
            known_answer[ans[i]] = i;
        }
    }

    if (!has_undef) {
        for (int i = 1; i <= n; i++) {
            cout << ans[i] << ' ';
        }
        cout << endl;
        return 0;
    }
    
    for (const vector<int> &part : partition) {
        if (part.size() == undefined_size) {
            if (undef_first.empty()) {
                undef_first = part;
            } else {
                undef_second = part;
            }
        }
    }
    if (undefined_size != 1) {
    int last_sz = 4;
    if (undefined_size == 1) {
        last_sz--;
    }
    vector<int> last_query(n + 1, 2);
    for (int i = 0; i < (int) undef_first.size(); i++) {
        last_query[undef_first[i]] = 4;
    }
    for (int i = 0; i < (int) undef_second.size(); i++) {
        last_query[undef_second[i]] = 3;
    }
    last_query[undef_first[0]] = 1;
    cout << last_sz << endl;
    for (int i = 1; i <= n; i++) {
        cout << last_query[i] << ' ';
    }
    cout << endl;

    vector<int> undef_first_result, undef_second_result;
    for (int t = 0; t < last_sz; t++) {
        int sz; cin >> sz;
        bool good = true;
        vector<int> g;
        for (int i = 0; i < sz; i++) {
            int x; cin >> x;
            g.push_back(x);
            if (known_answer[x]) {
                good = false;
            }
        }
        if (good) {
                for (int x : g) {
                    if (sz < undefined_size) undef_first_result.push_back(x);
                    else undef_second_result.push_back(x);
                }
        }
    }
    bool vis_first = false;
    for (const vector<int> &part : partition) {
        if (part.size() == undefined_size) {
            if (!vis_first) {
                for (int i : part) {
                    ans[i] = intersect(undef_first_result, vert_result[vert_num[i]]);
                }
                vis_first = true;
            } else {
                for (int i : part) {
                    ans[i] = intersect(undef_second_result, vert_result[vert_num[i]]);
                }
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        cout << ans[i] << ' ';
    }
    cout << endl;
    } else {
        cout << 2 << endl;
        cout << 1 << ' ';
        for (int i = 2; i <= n; i++) {
            cout << 2 << ' ';
        }
        cout << endl;
        for (int i = 0; i < 2; i++) {
            int sz; cin >> sz;
            if (sz == 1) {
                int x; cin >> x;
                ans[1] = x;
                known_answer[x] = 1;
            } else {
                for (int j = 0; j < sz; j++) {
                    int x; cin >> x;
                }
            }
        }
        int l = -1;
        for (int i = 1; i <= n; i++) {
            if (!known_answer[i]) {
                l = i;
                break;
            }
        }
        for (int i = 1; i <= n; i++) {
            if (ans[i] == -1) {
                ans[i] = l;
            }
        }
        for (int i = 1; i <= n; i++) {
            cout << ans[i] << ' ';
        }
        cout << endl;
    }
}