#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <ctime>
#include <cassert>
#include <chrono>
#include <vector>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

struct edge
{
	long long to, w;
};

long long n;
vector<edge> g[200000];
vector<long long> rga[200000], rgb[200000];
vector<long long> dsta, dstb, waya, wayb;
vector<bool> canget, notvisb;

void swdag()
{
	swap(rga, rgb);
	swap(dsta, dstb);
	swap(waya, wayb);
}

void dijkstra(long long fr, long long nd)
{
	vector<long long> dist(n, INF);
	dist[fr] = 0;
	set<pair<long long, long long>> q;
	q.insert({ 0, fr });
	while (q.size())
	{
		auto [dst, ver] = *q.begin();
		q.erase(q.begin());
		for (auto& i : g[ver])
		{
			if (dist[i.to] > dst + i.w)
			{
				q.erase({ dist[i.to], i.to });
				dist[i.to] = dst + i.w;
				q.insert({ dist[i.to], i.to });
			}
		}
	}
	dsta = dist;

	for (long long i = 0; i < n; i++)
	{
		if (i == nd)
		{
			continue;
		}
		for (auto& j : g[i])
		{
			if (dist[j.to] == dist[i] + j.w)
			{
				rga[j.to].push_back(i);
			}
		}
	}
}

void cntway(long long v)
{
	if (!canget[v])
	{
		waya[v] = 0;
		return;
	}
	if (waya[v] != -1)
	{
		return;
	}

	long long sum = 0;
	for (auto& i : rga[v])
	{
		if (canget[i])
		{
			cntway(i);
			sum += waya[i];
			sum %= MOD;
		}
	}
	waya[v] = sum;
}

void mark(long long v)
{
	canget[v] = true;
	for (auto& i : rga[v])
	{
		if (!canget[i])
		{
			mark(i);
		}
	}
}

void solve()
{
	long long m, a, b, l;
	cin >> n >> m;
	waya.resize(n, -1);
	wayb.resize(n, -1);
	notvisb.resize(n, false);
	canget.resize(n, true);
	cin >> a >> b >> l;
	a--; b--;
	for (long long i = 0; i < m; i++)
	{
		long long a, b, c;
		cin >> a >> b >> c;
		a--; b--;
		g[a].push_back({ b, c });
		g[b].push_back({ a, c });
	}

	swdag();
	dijkstra(b, -1);
	waya[b] = 1;
	for (long long i = 0; i < n; i++)
	{
		cntway(i);
	}
	swdag();
	dijkstra(a, b);
	canget.assign(n, false);
	mark(b);

	if (!canget[a])
	{
		cout << 0 << "\n";
		return;
	}

	waya[a] = 1;
	for (long long i = 0; i < n; i++)
	{
		cntway(i);
	}

	if (l == dsta[b])
	{
		cout << waya[b] << "\n";
	}
	else
	{
		long long ans = 0;
		for (long long i = 0; i < n; i++)
		{
			if (i == b)
			{
				continue;
			}
			for (auto& j : g[i])
			{
				if (dsta[i] + j.w + dstb[j.to] != l)
				{
					continue;
				}

				ans += (waya[i] * wayb[i]) % MOD;
				ans %= MOD;
			}
		}
		cout << ans << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*



















*/
