#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <ctime>
#include <cassert>
#include <chrono>
#include <vector>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

void solve()
{
	long long n, m;
	vector<string> t;
	cin >> n >> m;
	t.resize(n + 2);
	for (long long i = 1; i < n + 1; i++)
	{
		for (long long j = 1; j < m + 1; j++)
		{
			cin >> t[i][j];
		}
		t[i][0] = t[i].back() = '#';
	}
	t[0] = t.back() = string(m, '#');

	set<pair<long long, pair<long long, long long>>> st;
	vector<vector<long long>> e(n + 2, vector<long long>(m + 2));
	for (long long i = 1; i < n + 1; i++)
	{
		for (long long j = 1; j < m + 1; j++)
		{
			long long dx[4] = { -1, 0, 1, 0 }, dy[4] = { 0, 1, 0, -1 };
			if (t[i][j] == '#')
			{
				long long cnt = 0;
				for (long long _ = 0; _ < 4; _++)
				{
					long long x = i + dx[_], y = j + dy[_];
					if (t[x][y] == '#')
					{
						cnt++;
					}
				}
				st.insert({ cnt, {i, j} });
				e[i][j] = cnt;
			}
		}
	}
	while (st.size())
	{
		auto iii = *st.begin();
		if (iii.first > 1)
		{
			break;
		}
		st.erase(st.begin());

		long long i = iii.second.first;
		long long j = iii.second.second;
		e[i][j] = 0;
		long long dx[4] = { -1, 0, 1, 0 }, dy[4] = { 0, 1, 0, -1 };
		long long cnt = 0;
		for (long long _ = 0; _ < 4; _++)
		{
			long long x = i + dx[_], y = j + dy[_];
			if (t[x][y] == '#')
			{
				if (x != 0 && y != 0 && x != n + 1 && y != m + 1)
				{
					st.erase({ e[x][y], {x, y} });
					e[x][y]--;
					st.insert({ e[x][y], {x, y} });
				}
			}
		}
	}

	vector<string> ans(n, string(m, '#'));
	for (auto& i : st)
	{
		if (i.first != 4)
		{
			ans[i.second.first - 1][i.second.second - 1] = '#';
		}
	}
	for (long long i = 0; i < n; i++)
	{
		cout << ans[i] << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*



















*/
