#include <iostream>
#include <vector>
#include <algorithm>
#include<bits/stdc++.h>
#define int long long
#define ll long long
#define mxn 1e9 + 9

using namespace std;

struct segtree {
    vector <pair<int, int>> t;
    int sz;

    void init (int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        t.assign(2 * sz - 1, {mxn, -1});
    }

    void update (int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            t[x] = {v, i};
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            update(i, v, 2 * x + 1, lx, m);
        }
        else {
            update(i, v, 2 *  x+ 2, m, rx);
        }
        t[x] = min(t[2 * x + 1], t[2 * x + 2]);
    }

    pair<int, int> get (int l, int r, int x, int lx, int rx) {
        if (lx >= r || l >= rx) {
            return {mxn, -1};
        }
        if (lx >= l && rx <= r) {
            return t[x];
        }
        int m = (lx + rx) / 2;
        return min(get(l, r, 2 * x + 1, lx, m), get(l, r, 2 * x + 2, m, rx));
    }
};
#define all(a) a.begin(), a.end()

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, B, C;
    cin >> n >> B >> C;
    vector <ll> x(n), p(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> p[i];
    }
    vector <ll> r(n, n);
    stack <int> st1;
    st1.push(n - 1);
    segtree st;
    st.init(n);
    for (int i = 0; i < n; ++i) {
        st.update(i, p[i], 0, 0, n);
    }
    for (int i = n - 2; i >= 0; --i) {
        while (!st1.empty()) {
            if (p[st1.top()] > p[i]) {
                st1.pop();
            }
            else {
                break;
            }
        }
        if (!st1.empty()) {
            r[i] = st1.top();
        }
        st1.push(i);
    }
    int curr = 0, cnt = 0, ans = 0;
    while (true) {
        ans = x[curr];
        // cout << curr << endl;
        int can = min(C - cnt, B / p[curr]);
        if (r[curr] != n && x[r[curr]] - x[curr] <= can + cnt) {
            int need = max(0ll, x[r[curr]] - x[curr] - cnt);
            int dist = x[r[curr]] - x[curr];
            cnt += need;
            cnt -= dist;
            B -= need * p[curr];
            curr = r[curr];
        }
        else {
            cnt = cnt + can;
            B -= can * p[curr];
            int r = upper_bound(all(x), x[curr] + cnt) - x.begin();
            if (r == curr + 1) {
                ans = x[curr] + cnt;
                break;
            }
            else {
                auto t = st.get(curr + 1, r, 0, 0, n);
                cnt -= (x[t.second] - x[curr]);
                curr = t.second;
            }
        }
    }
    cout << ans << endl;
}
