#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#define int long long
#define pi pair<int, int>
using namespace std;
vector<int> dX = { 1, 0, -1, 0 };
vector<int> dY = { 0, 1, 0, -1 };
vector<int> dX2 = { 1, 1, -1, -1 };
vector<int> dY2 = { 1, -1, 1, -1 };
const int INF = 1e16;
const int MOD2 = 1e9 + 7;
vector<vector<pi>> g;
vector<int> d1;
vector<int> d2;
vector<vector<int>> g2;
vector<int> path;
vector<bool> used;
void BFS(int v, vector<int>& d) {
	int N = d.size();
	vector<bool> used;
	used.assign(N, false);
	d.assign(N, INF); d[v] = 0;
	priority_queue<pair<int, int>> q;
	q.push({ 0, v });
	while (!q.empty()) {
		int v = q.top().second; q.pop();
		if (used[v]) continue;
		used[v] = true;
		for (auto x : g[v]) {
			if (used[x.first]) continue;
			d[x.first] = min(d[x.first], d[v] + x.second);
			q.push({ -d[x.first], x.first });
		}
	}
}
void DFS(int v) {
	used[v] = true;
	for (auto x : g2[v]) {
		if (!used[x]) DFS(x);
		path[v] += path[x];
		if (path[v] >= MOD2) path[v] -= MOD2;
	}
}
void solve() {
	int N = 0, M = 0; cin >> N >> M;
	int S = 0, T = 0, L = 0; cin >> S >> T >> L;
	g.assign(N, vector<pi>());
	for (int k = 0; k < M; ++k) {
		int u = 0, v = 0, w = 0; cin >> u >> v >> w;
		u--; v--; g[u].push_back({ v, w });
		g[v].push_back({ u, w });
	}
	S--; T--;
	d1.assign(N, 0);
	d2.assign(N, 0);
	BFS(T, d1);
	BFS(S, d2);
	int dt = L - d1[S];
	if (dt < 0) {
		cout << 0 << "\n";
		return;
	}
	g2.assign(2 * N, vector<int>());
	for (int i = 0; i < N; ++i) {
		for (auto x : g[i]) {
			if (d1[x.first] == d1[i] - x.second) {
				g2[2 * i].push_back(2 * x.first);
				g2[2 * i + 1].push_back(2 * x.first + 1);
			}
			if (dt != 0 && d2[i] + d1[x.first] + x.second == L) g2[2 * i].push_back(2 * x.first + 1);
		}
	}
	used.assign(2 * N, false);
	path.assign(2 * N, 0);
	if (L == d1[S]) path[2 * T] = 1;
	else path[2 * T + 1] = 1;
	DFS(2 * S);
	path[2 * S] %= MOD2;
	cout << path[2 * S] << "\n";
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	cout << setprecision(20);
	solve();
	return 0;
}