#include <bits/stdc++.h>

using namespace std;
#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

template<class T>
struct RMQ {
    vector<vector<T>> jmp;

    explicit RMQ(const vector<T> &V) : jmp(1, V) {
        for (int pw = 1, k = 1; pw * 2 <= sz(V); pw *= 2, ++k) {
            jmp.emplace_back(sz(V) - pw * 2 + 1);
            rep(j, 0, sz(jmp[k])) jmp[k][j] = min(jmp[k - 1][j], jmp[k - 1][j + pw]);
        }
    }

    T query(int a, int b, T init) {
        if (a == b) return init;
        int dep = 31 - __builtin_clz(b - a);
        return min(jmp[dep][a], jmp[dep][b - (1 << dep)]);
    }
};

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);
    cout << fixed << setprecision(15);

    int n, b, c;
    cin >> n >> b >> c;

    vector<int> x(n), p(n);
    rep(i, 0, n) cin >> x[i] >> p[i];

    vector<pii> pi(n);
    rep(i, 0, n) pi[i] = {p[i], i};
    RMQ<pii> rmq(pi);

    int pos = 0, fuel = 0;
    while (pos < n - 1 && b > 0) {
        int mf = min(c, fuel + b / p[pos]);
        int ac = x[pos] + mf;

        int npos = upper_bound(all(x), ac) - x.begin();
        pii mc = rmq.query(pos + 1, npos, pii{-1, -1});
        if (mc.second == -1) {
            break;
        }

        if (mc.first < p[pos]) {
            b -= (x[mc.second] - x[pos] - fuel) * p[pos];
            pos = mc.second;
            fuel = 0;
        } else {
            int nxt = mc.second;
            b -= p[pos] * (c - fuel);
            fuel = c - (x[nxt] - x[pos]);
            pos = nxt;
        }
    }

    int ans = x[pos];
    if (b > 0) fuel = min(fuel + b / p[pos], c);
    ans += fuel;

    cout << ans << '\n';
}
