#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;
template<typename A, typename B>
string to_string(pair<A, B> p);


string to_string(string s){
    return '"' + s + '"';
}

string to_string(const char *s){
    return to_string((string)s);
}

string to_string(bool a){
    return (a ? "true" : "false");
}

template<typename A, typename B>
string to_string(pair<A, B> p){
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template<typename A>
string to_string(A v){
    bool f = 1;
    string res = "{";
    for(auto x : v){
        if (!f) res += ", ";
        res += to_string(x);
        f = 0;
    }
    res += "}";
    return res;
}

void debug_out(){
    cerr << endl;
}
template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T){
    cerr << " " << to_string(H);
    debug_out(T...);
}
#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

#define sz(a)(ll)(a).size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pikachu push_back
#define pll pair<ll, ll>
#define pii pair<int, int>
typedef long long ll;
typedef long double ld;


void run();
signed main() {
#ifdef LOCAL
    freopen("file.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    run();
}
ll n, m;

vector<vector<pll>> g;
const ll P = 1'000'000'007;

pair<vector<ll>, vector<ll>> dijkstra(ll s){
    priority_queue<pair<ll, ll>, vector<pll>, greater<pll>> q;
    vector<ll> d(n, 1e18);
    vector<ll> cnt(n, 0);
    d[s] = 0;
    q.push({d[s], s});
    cnt[s] = 1;
    while (!q.empty()){
        auto [dd, vv] = q.top();
        q.pop();
        if (dd != d[vv]){
            continue;
        }
        for (auto [u, w] : g[vv]){
            if (d[u] > w + d[vv]){
                d[u] = w + d[vv];
                q.push({d[u], u});
                cnt[u] = cnt[vv];
            } else if (d[u] == w + d[vv]){
                cnt[u] += cnt[vv];
                cnt[u] %= P;
            }
        }
    }
    return {d, cnt};
}

void run(){
    cin >> n >> m;
    ll s, t, L;
    cin >> s >> t >> L;
    --s; --t;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        ll a, b, c;
        cin >> a >> b >> c;
        --a; --b;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    auto [from_s, go_from_s] = dijkstra(s);
    auto [to_t, go_to_t] = dijkstra(t);
    ll ans = 0;
    if (L == from_s[t]){
        cout << go_from_s[t] << endl;
        return;
    }
    for (int i = 0; i < n; ++i){
        for (auto [u, w] : g[i]){
            if (i != t){
                if (from_s[i] + to_t[i] == from_s[t] && from_s[i] + to_t[u] + w == L){
                    //debug(i, u);
                    ans += go_from_s[i] * go_to_t[u] % P;
                    ans %= P;
                }
            }
        }
    }
//    debug(from_s);
//    debug(to_t);
//    debug(go_from_s);
//    debug(go_to_t);
    cout << ans << endl;
}
