#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
#include <deque>

using namespace std;
typedef long long ll;
#define int long long

const int N = 200010;
int n, m;
int s, t, L;
vector <pair <int, int>> g[N];
const int MOD = 1000000007;

int ds[N];
int dt[N];
int cs[N];
int ct[N];
const int inf = 1e18;

void bfs(int u, int* dst, int* cnt)
{
	for (int i = 1; i <= n; ++i) dst[i] = inf;
	dst[u] = 0;
	cnt[u] = 1;
	set <pair <int, int>> se;
	for (int i = 1; i <= n; ++i) se.insert({ dst[i], i });
	while (se.size())
	{
		auto u = se.begin()->second;
		se.erase(se.begin());
		for (auto v : g[u])
		{
			if (dst[v.first] > dst[u] + v.second)
			{
				se.erase({ dst[v.first], v.first });
				dst[v.first] = dst[u] + v.second;
				se.insert({ dst[v.first], v.first });
			}
		}

		for (auto v : g[u])
		{
			if (dst[v.first] + v.second == dst[u])
			{
				cnt[u] += cnt[v.first];
				cnt[u] %= MOD;
			}
		}
	}
}
int ans;
signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;
	cin >> s >> t >> L;

	for (int i = 1; i <= m; ++i)
	{
		int u, v, w;
		cin >> u >> v >> w;
		g[u].push_back({ v, w });
		g[v].push_back({ u, w });
	}

	bfs(s, ds, cs);
	bfs(t, dt, ct);

	int mini = ds[t];
	if (mini > L)
	{
		cout << 0;
		return 0;
	}
	if (mini == L)
	{
		assert(cs[t] == ct[s]);
		cout << cs[t] % MOD;
		return 0;
	}

	for (int i = 1; i <= n; ++i)
	{
		if (ds[i] + dt[i] != mini)
		{
			continue;
		}

		for (auto v : g[i])
		{
			if (dt[v.first] + v.second + ds[i] != L) continue;
			ans += (ll)cs[i] * ct[v.first] % MOD;
			ans %= MOD;
		}
	}

	cout << ans % MOD;

	return 0;
}