#include <iostream>
#include <cmath>
#include <algorithm>
#include <map>
#include <vector>
#include <set>
#include <deque>
using namespace std;

typedef long long ll;

#define int ll

const int MOD = 1e9 + 7;

vector<vector<pair<int ,int>>> t;

void build(int v, int l, int r, vector<int>& arr) {
	if (l + 1 == r) {
		t[v].push_back({arr[l], l});
		return;
	}
	int mid = (l + r) / 2;
	build(2 * v + 1, l, mid, arr);
	build(2 * v + 2, mid, r, arr);
	t[v].resize(r - l);
	merge(t[2 * v + 1].begin(), t[2 * v + 1].end(), t[2 * v + 2].begin(), t[2 * v + 2].end(), t[v].begin());
}

int get_cnt(int v, int l, int r, int a, int b, int x) {
	if (b <= l || r <= a) {
		return 0;
	}
	if (a <= l && r <= b) {
		auto it = lower_bound(t[v].begin(), t[v].end(), make_pair( x, -1LL ));
		return t[v].end() - it;
	}
	int mid = (l + r) / 2;
	return get_cnt(2 * v + 1, l, mid, a, b, x) + get_cnt(2 * v + 2, mid, r, a, b, x);
}

pair<int, int> get_inds(int v, int l, int r, int a, int b, int x) {
	if (b <= l || r <= a) {
		return { -1, -1 };
	}
	if (a <= l && r <= b) {
		auto it = lower_bound(t[v].begin(), t[v].end(), make_pair(x, -1LL));
		int cnt = t[v].end() - it;
		if (cnt == 0) {
			return { -1, -1 };
		}
		if (cnt == 1) {
			return { it->second, -1 };
		}
		else {
			auto it1 = it;
			it1++;
			return { it->second, it1->second };
		}
	}
	int mid = (l + r) / 2;
	auto v1 = get_inds(2 * v + 1, l, mid, a, b, x);
	auto v2 = get_inds(2 * v + 2, mid, r, a, b, x);
	if (v1.second != -1) {
		return v1;
	}
	else if (v2.second != -1) {
		return v2;
	}
	else if (v1.first == -1) {
		return v2;
	}
	else if (v2.first == -1) {
		return v1;
	}
	else {
		return { v1.first, v2.first };
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	/*int n;
	cin >> n;
	t.resize(4 * n);
	vector<int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	build(0, 0, n, arr);
	int q;
	cin >> q;
	while (q--) {
		int l, r;
		cin >> l >> r;
		l--, r--;
		if (l == r) {
			cout << arr[l] << '\n';
			continue;
		}
		int L = -1, R = 1e9 + 1;
		while (L + 1 < R) {
			int mid = (L + R) / 2;
			if (get_cnt(0, 0, n, l, r + 1, mid) > 2) {
				L = mid;
				continue;
			}
			if (get_cnt(0, 0, n, l, r + 1, mid) <= 1) {
				R = mid;
				continue;
			}
			pair<int, int> aaa = get_inds(0, 0, n, l, r + 1, mid);
			cout << mid << ' ' << aaa.first << ' ' << aaa.second << '\n';
			if ((aaa.second - aaa.first) % 2 == 0 || abs(aaa.second - aaa.first) == 1) {
				L = mid;
			}
			else {
				R = mid;
			}
		}
		cout << L << '\n';
	}*/
	
	int n, m;
	cin >> n >> m;;
	int s, t, l;
	cin >> s >> t >> l;
	s--, t--;
	vector<vector<pair<int, int>>> graph(n);
	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		a--, b--;
		graph[a].push_back({ b, c });
		graph[b].push_back({ a, c });
	}
	set<pair<int, int>> ss;
	vector<pair<int, int>> dist1(n, { LLONG_MAX, 0 });
	dist1[s] = { 0, 1 };
	ss.insert({ dist1[s].first, s });
	while (!ss.empty()) {
		int v = ss.begin()->second;
		ss.erase(ss.begin());
		for (auto to : graph[v]) {
			if (dist1[to.first].first > dist1[v].first + to.second) {
				ss.erase({ dist1[to.first].first, to.first });
				dist1[to.first].first = dist1[v].first + to.second;
				dist1[to.first].second = dist1[v].second;
				ss.insert({ dist1[to.first].first, to.first });
			}
			else if (dist1[to.first].first == dist1[v].first + to.second) {
				dist1[to.first].second += dist1[v].second;
				dist1[to.first].second %= MOD;
			}
		}
	}
	vector<pair<int, int>> dist2(n, { LLONG_MAX, 0 });
	dist2[t] = { 0, 1 };
	ss.insert({ dist2[t].first, t });
	while (!ss.empty()) {
		int v = ss.begin()->second;
		ss.erase(ss.begin());
		for (auto to : graph[v]) {
			if (dist2[to.first].first > dist2[v].first + to.second) {
				ss.erase({ dist2[to.first].first, to.first });
				dist2[to.first].first = dist2[v].first + to.second;
				dist2[to.first].second = dist2[v].second;
				ss.insert({ dist2[to.first].first, to.first });
			}
			else if (dist2[to.first].first == dist2[v].first + to.second) {
				dist2[to.first].second += dist2[v].second;
				dist2[to.first].second %= MOD;
			}
		}
	}
	int ans = 0;
	if (l == dist1[t].first) {
		cout << dist1[t].second << '\n';
	}
	else {
		for (int i = 0; i < n; i++) {
			for (auto to : graph[i]) {
				if (i != t && dist1[i].first + dist2[to.first].first + to.second == l && dist1[i].first + dist2[i].first == dist1[t].first) {
					// cout << '?' << i << ' ' << to.first << ' ' << dist1[i].second << ' ' << dist2[to.first].second << '\n';
					ans += dist1[i].second * dist2[to.first].second % MOD;
					ans %= MOD;
				}
			}
		}
		cout << ans << '\n';

	}
	
}