#include <iostream>
#include <cmath>
#include <algorithm>
#include <map>
#include <vector>
#include <set>
#include <deque>
using namespace std;

typedef long long ll;

#define int ll

const int MOD = 1e9 + 7;

vector<vector<pair<int ,int>>> t;

void build(int v, int l, int r, vector<int>& arr) {
	if (l + 1 == r) {
		t[v].push_back({arr[l], l});
		return;
	}
	int mid = (l + r) / 2;
	build(2 * v + 1, l, mid, arr);
	build(2 * v + 2, mid, r, arr);
	t[v].resize(r - l);
	merge(t[2 * v + 1].begin(), t[2 * v + 1].end(), t[2 * v + 2].begin(), t[2 * v + 2].end(), t[v].begin());
}

int get_cnt(int v, int l, int r, int a, int b, int x) {
	if (b <= l || r <= a) {
		return 0;
	}
	if (a <= l && r <= b) {
		auto it = lower_bound(t[v].begin(), t[v].end(), make_pair( x, -1LL ));
		return t[v].end() - it;
	}
	int mid = (l + r) / 2;
	return get_cnt(2 * v + 1, l, mid, a, b, x) + get_cnt(2 * v + 2, mid, r, a, b, x);
}

pair<int, int> get_inds(int v, int l, int r, int a, int b, int x) {
	if (b <= l || r <= a) {
		return { -1, -1 };
	}
	if (a <= l && r <= b) {
		auto it = lower_bound(t[v].begin(), t[v].end(), make_pair(x, -1LL));
		int cnt = t[v].end() - it;
		if (cnt == 0) {
			return { -1, -1 };
		}
		if (cnt == 1) {
			return { it->second, -1 };
		}
		else {
			auto it1 = it;
			it1++;
			return { it->second, it1->second };
		}
	}
	int mid = (l + r) / 2;
	auto v1 = get_inds(2 * v + 1, l, mid, a, b, x);
	auto v2 = get_inds(2 * v + 2, mid, r, a, b, x);
	if (v1.second != -1) {
		return v1;
	}
	else if (v2.second != -1) {
		return v2;
	}
	else if (v1.first == -1) {
		return v2;
	}
	else if (v2.first == -1) {
		return v1;
	}
	else {
		return { v1.first, v2.first };
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	/*int n;
	cin >> n;
	t.resize(4 * n);
	vector<int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	build(0, 0, n, arr);
	int q;
	cin >> q;
	while (q--) {
		int l, r;
		cin >> l >> r;
		l--, r--;
		if (l == r) {
			cout << arr[l] << '\n';
			continue;
		}
		int L = -1, R = 1e9 + 1;
		while (L + 1 < R) {
			int mid = (L + R) / 2;
			if (get_cnt(0, 0, n, l, r + 1, mid) > 2) {
				L = mid;
				continue;
			}
			if (get_cnt(0, 0, n, l, r + 1, mid) <= 1) {
				R = mid;
				continue;
			}
			pair<int, int> aaa = get_inds(0, 0, n, l, r + 1, mid);
			cout << mid << ' ' << aaa.first << ' ' << aaa.second << '\n';
			if ((aaa.second - aaa.first) % 2 == 0 || abs(aaa.second - aaa.first) == 1) {
				L = mid;
			}
			else {
				R = mid;
			}
		}
		cout << L << '\n';
	}*/
	
	int n, m;
	cin >> n >> m;
	vector<vector<char>> arr(n, vector<char>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> arr[i][j];
		}
	}
	vector<vector<bool>> used(n, vector<bool>(m));
	int move_x[4] = { -1, 0, 0, 1 };
	int move_y[4] = { 0, -1, 1, 0 };
	vector<pair<int, int>> prud;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (arr[i][j] == '.' && !used[i][j]) {
				deque<pair<int, int>> q;
				q.push_back({ i, j });
				used[i][j] = true;
				vector<pair<int, int>> comp;
				while (!q.empty()) {
					int x = q.front().first, y = q.front().second;
					q.pop_front();
					comp.push_back({ x, y });
					for (int k = 0; k < 4; k++) {
						int new_x = x + move_x[k];
						int new_y = y + move_y[k];
						if (0 <= new_x && new_x < n && 0 <= new_y && new_y < m) {
							if (!used[new_x][new_y] && arr[new_x][new_y] == '.') {
								used[new_x][new_y] = true;
								q.push_back({ new_x, new_y });
							}
						}
					}
				}
				bool flag = true;
				for (auto el : comp) {
					if (el.first == 0 || el.first == n - 1 || el.second == 0 || el.second == m - 1) {
						flag = false;
					}
				}
				if (flag) {
					prud = comp;
					break;
				}
			}
		}
	}
	vector<vector<int>> cnt(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (arr[i][j] == '#') {
				for (int k = 0; k < 4; k++) {
					int new_x = i + move_x[k], new_y = j + move_y[k];
					if (0 <= new_x && new_x < n && 0 <= new_y && new_y < m) {
						if (arr[new_x][new_y] == '#') {
							cnt[i][j]++;
						}
					}
				}
			}
		}
	}
	vector<vector<bool>> ggg(n, vector<bool>(m));
	for (auto el : prud) {
		ggg[el.first][el.second] = true;
	}
	vector<pair<int, int>> cycle;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (arr[i][j] == '#' && cnt[i][j] >= 2) {
				bool flag = false;
				for (int a = -1; a <= 1; a++) {
					for (int b = -1; b <= 1; b++) {
						int new_i = i + a, new_j = j + b;
						if (0 <= new_i && new_i < n && 0 <= new_j && new_j < m) {
							if (ggg[new_i][new_j]) {
								flag = true;
							}
						}
					}
				}
				if (flag) {
					cycle.push_back({ i, j });
				}
			}
		}
	}
	vector<vector<char>> ans(n, vector<char>(m, '.'));
	for (auto el : cycle) {
		ans[el.first][el.second] = '#';
	}
	for (int i = 0; i < n; i++) {

		for (int j = 0; j < m; j++) {
			cout << ans[i][j];
		}
		cout << '\n';
	}
}