#include <iostream>
#include <cmath>
#include <algorithm>
#include <map>
#include <vector>
#include <set>
#include <deque>
using namespace std;

typedef long long ll;

#define int ll

const int MOD = 1e9 + 7;

vector<vector<pair<int ,int>>> t;

void build(int v, int l, int r, vector<int>& arr) {
	if (l + 1 == r) {
		t[v].push_back({arr[l], l});
		return;
	}
	int mid = (l + r) / 2;
	build(2 * v + 1, l, mid, arr);
	build(2 * v + 2, mid, r, arr);
	t[v].resize(r - l);
	merge(t[2 * v + 1].begin(), t[2 * v + 1].end(), t[2 * v + 2].begin(), t[2 * v + 2].end(), t[v].begin());
}

int get_cnt(int v, int l, int r, int a, int b, int x) {
	if (b <= l || r <= a) {
		return 0;
	}
	if (a <= l && r <= b) {
		auto it = lower_bound(t[v].begin(), t[v].end(), make_pair( x, -1LL ));
		return t[v].end() - it;
	}
	int mid = (l + r) / 2;
	return get_cnt(2 * v + 1, l, mid, a, b, x) + get_cnt(2 * v + 2, mid, r, a, b, x);
}

pair<int, int> get_inds(int v, int l, int r, int a, int b, int x) {
	if (b <= l || r <= a) {
		return { -1, -1 };
	}
	if (a <= l && r <= b) {
		auto it = lower_bound(t[v].begin(), t[v].end(), make_pair(x, -1LL));
		int cnt = t[v].end() - it;
		if (cnt == 0) {
			return { -1, -1 };
		}
		if (cnt == 1) {
			return { it->second, -1 };
		}
		else {
			auto it1 = it;
			it1++;
			return { it->second, it1->second };
		}
	}
	int mid = (l + r) / 2;
	auto v1 = get_inds(2 * v + 1, l, mid, a, b, x);
	auto v2 = get_inds(2 * v + 2, mid, r, a, b, x);
	if (v1.second != -1) {
		return v1;
	}
	else if (v2.second != -1) {
		return v2;
	}
	else if (v1.first == -1) {
		return v2;
	}
	else if (v2.first == -1) {
		return v1;
	}
	else {
		return { v1.first, v2.first };
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	/*int n;
	cin >> n;
	t.resize(4 * n);
	vector<int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	build(0, 0, n, arr);
	int q;
	cin >> q;
	while (q--) {
		int l, r;
		cin >> l >> r;
		l--, r--;
		if (l == r) {
			cout << arr[l] << '\n';
			continue;
		}
		int L = -1, R = 1e9 + 1;
		while (L + 1 < R) {
			int mid = (L + R) / 2;
			if (get_cnt(0, 0, n, l, r + 1, mid) > 2) {
				L = mid;
				continue;
			}
			if (get_cnt(0, 0, n, l, r + 1, mid) <= 1) {
				R = mid;
				continue;
			}
			pair<int, int> aaa = get_inds(0, 0, n, l, r + 1, mid);
			cout << mid << ' ' << aaa.first << ' ' << aaa.second << '\n';
			if ((aaa.second - aaa.first) % 2 == 0 || abs(aaa.second - aaa.first) == 1) {
				L = mid;
			}
			else {
				R = mid;
			}
		}
		cout << L << '\n';
	}*/
	
	int n;
	cin >> n;
	cout << n << endl;
	for (int i = 1; i <= n; ++i) {
		cout << i << " ";
	}
	cout << endl;
	vector <int> ans(n);
	for (int i = 1; i <= n; ++i) {
		int s;
		cin >> s;
		cin >> ans[i - 1];
	}	
	cout << n << endl;
	for (int i = 1; i <= n; ++i) {
		cout << i << " ";
	}
	cout << endl;	cout << n << endl;
	for (int i = 1; i <= n; ++i) {
		cout << i << " ";
	}
	cout << endl;
	for (int i = 0; i < n; ++i) {
		cout << ans[i] << " ";
	}
	cout << endl;

	/*int h, w;
	cin >> h >> w;
	vector<vector<int>> dp(w + 1, vector<int>(h + 1));
	vector<vector<int>> dp1(w + 1, vector<int>(h + 1));
	for (int n = 1; n <= w; n++) {
		for (int m = 1; m <= h; m++) {
			dp[n][m] = n * m;
			dp1[n][m] = 1;
			for (int a = 1; a <= n - 2; a++) {
				int tmp1 = 0, tmp = 0;
				for (int b = 1; b <= m - 2; b++) {
					// dp[n][m] += (n - a - 1) * (m - b - 1) * (dp[a][b] + n * m * dp1[a][b]);
					// dp[n][m] += (n - a - 1) * (m - b - 1) * dp[a][b] + (n - a - 1) * (m - b - 1) * dp1[a][b] * n * m;

					// dp[n][m] += (n - a - 1) * (m - b - 1) * dp[a][b];
					tmp += (m - b - 1) * dp[a][b];


					// dp1[n][m] += (n - a - 1) * (m - b - 1) * dp1[a][b];
					tmp1 += (m - b - 1) * dp1[a][b];
				}
				dp[n][m] += (n - a - 1) * tmp;
				dp[n][m] += (n - a - 1) * tmp1 * n * m;
				dp1[n][m] += (n - a - 1) * tmp1;
			}

		}
	}
	cout << dp[w][h];*/
}