#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

ld eps = 1e-7;

ostream& operator << (ostream& out, vector<int>& vec) {
    for (int el :vec) {
        out << el << ' ';
    }
    return out;
}

ostream& operator << (ostream& out, vector<bool>& vec) {
    for (bool el :vec) {
        if (el)
            out << '#';
        else
            out << '.';
    }
    return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& vec) {
    for (T el :vec) {
        out << el << '\n';
    }
    return out;
}


const int N = 1e5 + 10;
const int LOG_N = 20;
pair<ll, int> sparse[LOG_N][N];
int lg2[N];

void build_table(vector<ll>& a) {
    for (int i = 0; i < a.size(); ++i) {
        sparse[0][i] = make_pair(a[i], i);
    }
    lg2[0] = 0;
    lg2[1] = 0;
    for (int i = 2; i < N; ++i) {
        lg2[i] = lg2[i / 2] + 1;
    }
    for (int k = 1; k < LOG_N; ++k) {
        for (int i = 0; i + (1 << (k - 1)) < a.size(); ++i) {
            sparse[k][i] = min(sparse[k - 1][i], sparse[k - 1][i + (1 << (k - 1))]);
        }
    }
}

int get_min(int l, int r) {
    int lg = lg2[r - l + 1];
    return min(sparse[lg][l], sparse[lg][r - (1 << lg) + 1]).second;
}

bool check(ll m, vector<ll>& x, vector<ll>& cost, ll b, ll c) {
    while (m > 0) {
        int l = lower_bound(x.begin(), x.end(), m - c) - x.begin();
        if (l == x.size())
            return false;
        int r = lower_bound(x.begin(), x.end(), m) - x.begin() - 1;
        cout << m << ' ' << l << ' ' << r << '\n';
        ll mn = get_min(l, r);
        ll x1 = x[mn];
        cout << (m - x1) * (ll) cost[mn] << '\n';
        if ((m - x1) * (ll) cost[mn] > b)
            return false;
        b -= (m - x1) * mn;
        m = x1;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    //freopen("input.txt", "r", stdin);
    int n;
    ll b, c;
    cin >> n >> b >> c;
    vector<ll> place(n), cost(n);
    set<pair<ll, int>> future;
    for (int i = 0; i < n; ++i) {
        cin >> place[i] >> cost[i];
    }
    ll x = 0, i = 0, j = 1, bak = 0;
    while (true) {
        //cout << "added: ";
        while (j < n && place[i] + min(c, b / cost[i]) + bak >= place[j]) {
            future.insert(make_pair(cost[j], j));
            //cout << j << ' ';
            ++j;
        }
        //cout << '\n';
        if (future.empty()) {
            x += min(b / cost[i], c) + bak;
            break;
        }
        auto it_less = future.upper_bound(make_pair(cost[i], 0));
        int less = -1;
        if (it_less == future.begin()) {
            //cout << "first " << '\n';
            less = future.begin()->second;
            bak += min(b / cost[i], c);
            b -= min(b / cost[i], c) * cost[i];
        }
        else {
            //cout << "second " << '\n';
            --it_less;
            less = it_less->second;
            bak += (place[less] - x);
            b -= (place[less] - x) * cost[i];
        }
        ///cout << i << ' ' << less << '\n';
        bak -= (place[less] - x);
        x = place[less];
        while (i < less) {
            ++i;
            future.erase(make_pair(cost[less], less));
        }
    }
    cout << x;
}
