#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,fma,sse2,sse3,ssse3,sse4,sse4.1,lzcnt,popcnt,bmi,bmi2")

#include <iostream>
#include <vector>

using namespace std;

typedef long long int ll;

struct segment_tree {
    segment_tree *lt, *rt;
    ll sum, lb, rb;

    segment_tree() {
        lb = 0;
        rb = 0;
        lt = nullptr;
        rt = nullptr;
        sum = 0;
    }

    segment_tree(ll l, ll r) {
        lb = l;
        rb = r;
        lt = nullptr;
        rt = nullptr;
        sum = 0;
    }

    void extend() {
        if (lt == nullptr) {
            ll m = (lb + rb) / 2;
            lt = new segment_tree(lb, m);
            rt = new segment_tree(m, rb);
        }
    }

    ll get(ll ql, ll qr) {
        if (rb <= ql || qr <= lb) {
            return 0;
        }
        if (ql <= lb && rb <= qr) {
            return sum;
        }
        extend();
        return lt->get(ql, qr) + rt->get(ql, qr);
    }

    void upd(ll ind, ll val) {
        if (rb - lb == 1) {
            sum = val;
            return ;
        }
        extend();
        ll m = (lb + rb) / 2;
        if (ind < m) {
            lt->upd(ind, val);
        } else {
            rt->upd(ind, val);
        }
        sum = lt->sum + rt->sum;
    }
};

void solve() {
    ll n, q, i, x, y, lb, rb, mid;
    segment_tree stree;

    stree = segment_tree(0, 2ll * 1000000007);

    cin >> n >> q;

    for (i = 0; i < n; i++) {
        cin >> x;
        stree.upd(x, 1);
    }

    for (i = 0; i < q; i++) {
        cin >> x;
        lb = -1;
        rb = 2ll * 1000000007;
        while (rb - lb > 1) {
            mid = (lb + rb) / 2;
            if (mid - stree.get(0, mid) < x) {
                lb = mid;
            } else {
                rb = mid;
            }
        }
        cout << lb << '\n';
    }
}

int main() {
    solve();
    return 0;
}