#include <bits/stdc++.h>

#define int long long

using namespace std;

const int MOD = 1e9 + 7, MAXN = 2e5 + 1;

int ans = 0, l;

vector<vector<pair<int, int>>> g(MAXN);

vector<int> get_dist(int start, vector<int> &cnt) {
    vector<int> dist(MAXN, 1e18);
    dist[start] = 0;
    set<pair<int, int>> q = {{0, start}};
    cnt[start] = 1;
    while (!q.empty()) {
        int u = q.begin()->second;
        q.erase(q.begin());
        for (auto [v, w] : g[u]) {
            if (dist[u] + w < dist[v]) {
                dist[v] = dist[u] + w;
                cnt[v] = cnt[u];
                q.insert({dist[v], v});
            } else if (dist[u] + w == dist[v]) {
                cnt[v] += cnt[u];
                q.insert({dist[v], v});
            }
        }
    }
    return dist;
}

void dfs(int v, int finish, vector<bool> &used, vector<int> &dist_from_s, vector<int> &dist_from_f, vector<int> &cnt_from_s, vector<int> &cnt_from_f) {
    used[v] = true;
    for (auto [u, w] : g[v]) {
        if (dist_from_s[v] + w + dist_from_f[u] == l) {
            ans += cnt_from_s[v] * cnt_from_f[u];
            ans %= MOD;
        }
        if (!used[u] && dist_from_s[v] + w + dist_from_f[u] == dist_from_s[finish]) {
            dfs(u, finish, used, dist_from_s, dist_from_f, cnt_from_s, cnt_from_f);
        }
    }
}

signed main() {
    //ifstream cin("text.in");
    //ofstream cout("text.out");
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, m, s, f, i, v, u, w;
    cin >> n >> m >> s >> f >> l;
    vector<int> cnt_from_s(MAXN, 0), cnt_from_f(MAXN, 0);
    for (i = 0; i < m; i++) {
        cin >> v >> u >> w;
        g[v - 1].push_back({u - 1, w});
        g[u - 1].push_back({v - 1, w});
    }
    vector<int> dist_from_s = get_dist(s - 1, cnt_from_s), dist_from_f = get_dist(f - 1, cnt_from_f);
    vector<bool> used(n, false);
    dfs(s - 1, f - 1, used, dist_from_s, dist_from_f, cnt_from_s, cnt_from_f);
    /*for (i = 0; i < n; i++) {
        cout << dist_from_s[i] << ' ';
    }
    cout << '\n';
    for (i = 0; i < n; i++) {
        cout << dist_from_f[i] << ' ';
    }
    cout << '\n';*/
    /*for (i = 0; i < n; i++) {
        cout << cnt_from_s[i] << ' ';
    }
    cout << '\n';
    for (i = 0; i < n; i++) {
        cout << cnt_from_f[i] << ' ';
    }
    cout <<'\n';
    */cout << ans;
    return 0;
}
