#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
#define vec vector
#define int ll
//#define endl '\n'

//typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
template<typename T> tree<T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const double eps = 1e-9;
const int inf = 1e18, sz = 30, SIZE = (1 << sz);

//template<typename T>
class Tree {
public:
    struct node {
        int val;
        node *l, *r;
        node() : val(inf), l(nullptr), r(nullptr) {}
        void upd() {
            val = std::min((l ? l->val : inf), (r ? r->val : inf));
        }
    };

    void set(int h, int s) {
        set(root, 0, SIZE, h, s);
    }

    int min(int h) {
        return min(root, 0, SIZE, h);
    }

private:
    node *root = nullptr;

    void set(node *&t, int l, int r, int h, int s) {
        if (!t)
            t = new node;
        if (l + 1 == r)
            return void(t->val = s);
        int u = (l + r) >> 1;
        if (h < u)
            set(t->l, l, u, h, s);
        else
            set(t->r, u,  r, h, s);
        t->upd();
    }

    int min(node *t, int l, int r, int h) {
        if (!t || h <= l)
            return inf;
        if (r <= h)
            return t->val;
        int u = (l + r) >> 1;
        return std::min(min(t->l, l, u, h), min(t->r, u, r, h));
    }
};

struct node {
    int b, c;
    node(int b = 0, int c = 0) : b(b), c(c) {}
};

void solve() {
    int n, B, C;
    cin >> n >> B >> C;
    Tree t;
    vector<int> x(n + 1), p(n + 1), next(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> x[i] >> p[i];
    for (int i = n; 0 < i; i--) {
        next[i] = t.min(p[i] + 1);
        t.set(p[i] + 1, i);
//        cout << next[i] << ' ';
    }
//    cout << '\n';
    vector<node> dp(n + 1);
    dp[0] = node(B, 0);
    for (int i = 1; i <= n; i++) {
        if (dp[i - 1].c < x[i] - x[i - 1])
            break;
        int h = dp[i - 1].c - (x[i] - x[i - 1]);
        if (next[i] == inf) {
            dp[i] = {dp[i - 1].b - min(C - h, dp[i - 1].b / p[i]) * p[i], min(C, h + dp[i - 1].b / p[i])};
        } else if (x[next[i]] - x[i] < h) {
            dp[i] = {dp[i - 1].b, h};
        } else {
                int pp = x[next[i]] - x[i] - h, c = min({C, pp, dp[i - 1].b / p[i]});
                dp[i] = {dp[i - 1].b - c * p[i], c};
        }
//        cout << dp[i].b << ' ' << dp[i].c << '\n';
    }
    int m = 0;
    for (int i = 0; i <= n; i++)
        m = max(m, dp[i].c + x[i]);
    cout << m;
}

signed main() {
#ifdef BIBIKOV
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
