#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 10e6;


vector<pair<int, int>> t(4*MAXN);

void build(vector<int> a, int v, int tl, int tr) {
    if (tl == tr) {
        t[v].first = a[tl];
        t[v].second = a[tl];
    }
    else {
        int tm = (tl + tr) / 2;
        build(a, v*2, tl, tm);
        build(a, v*2+1, tm+1, tr);
        t[v].first = min(t[v*2].first, t[v*2+1].first);
        t[v].second = max(t[v*2].second, t[v*2+1].second);
    }
}

void update(int v, int tl, int tr, int pos, int new_val) {
    if (tl == tr) {
        t[v].first = new_val;
        t[v].second = new_val;
    }
    else {
        int tm = (tl + tr) / 2;
        if (pos <= tm) update(v*2, tl, tm, pos, new_val);
        else update(v*2+1, tm+1, tr, pos, new_val);
        t[v].first = min(t[v*2].first, t[v*2+1].first);
        t[v].second = max(t[v*2].second, t[v*2+1].second);
    }
}

int main() {
    int n;
    cin >> n;
    vector<int> data(n);
    for (int i=0; i<n; i++) cin >> data[i];
    sort(data.begin(), data.end());
    vector<int> res(n / 2, 0);
    int minn = 1000000000;
    for (int i = 0; i < n / 2; i++) {
        res[i] = data[i] + data[n - i - 1];
    }
    build(res, 1, 0, n / 2 - 1);
    minn = min(minn, abs(t[1].first - t[1].second));
    int cnt = 0;
    for (int i = n - 1; i > -1; i--) {
        if (i > n / 2) {
            update(1, 0, n / 2 - 1, cnt + 1, res[cnt] - data[n - cnt - 1] + data[n - cnt]);
            minn = min(minn, abs(t[1].first - t[1].second));
            cnt += 1;
        } else {
            update(1, 0, n / 2 - 1, cnt + 1, res[cnt] - data[cnt - 1] + data[cnt]);
            minn = min(minn, abs(t[1].first - t[1].second));
            cnt -= 1;
        }
    }

    cout << minn;

    return 0;
}
