#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

vector<pair<int, int>> Tree, a;

pair<int, int> Union(pair<int, int> p1, pair<int, int> p2) {
    return {min(p1.first, p2.first), max(p1.second, p2.second)};
}


void Build(int i, int L, int R) {
    if (L == R) {
        Tree[i] = a[L];
    } else {
        Build(2 * i, L, (L + R) / 2);
        Build(2 * i + 1,(L + R) / 2 + 1, R);
        Tree[i] = Union(Tree[2 * i], Tree[2 * i + 1]);
    }
}


void Update(int i, int L, int R, int idx, int value) {
    if (L == R)
        Tree[i] = {value, value};
    else {
        int M = (L + R) / 2;
        if (idx <= M)
            Update(i * 2, L, M, idx, value);
        else
            Update(i * 2 + 1, M + 1, R, idx, value);
        Tree[i] = Union(Tree[i * 2], Tree[i * 2 + 1]);
    }
}


pair<int, int> Get(int i, int L, int R, int l, int r) {
    if (l > r)
        return {2e9, 0};
    else if (l == L and r == R)
        return Tree[i];
    else {
        int M = (L + R) / 2;
        pair<int, int> T1, T2;
        T1 = Get(2 * i, L, M, l, min(M, r));
        T2 = Get(2 * i + 1, M + 1, R, max(M + 1, l), r);
        return Union(T1, T2);
    }
}


signed main() {
    int N;
    cin >> N;
    Tree.resize(N / 2 * 4);
    a.resize(N / 2);
    vector<int> x(N);
    for (int i = 0; i < N; ++i)
        cin >> x[i];
    sort(x.begin(), x.end());
    for (int i = 0; i < N / 2; ++i) {
        a[i] = {x[i + 1] + x[N - i - 1], x[i + 1] + x[N - i - 1]};
    }
    Build(1, 0, N / 2 - 1);
    auto gt = Get(1, 0, N / 2 - 1, 0, N / 2 - 1);
    int ans = gt.second - gt.first;
    for (int i = 1; i <= N / 2; ++i) {
        Update(1, 0, N / 2 - 1, i - 1, x[i - 1] + x[N - i]);
        gt = Get(1, 0, N / 2 - 1, 0, N / 2 - 1);
        ans = min(ans, gt.second - gt.first);
    }
    for (int i = N / 2 + 1; i < N; ++i) {
        Update(1, 0, N / 2 - 1, N - i - 1, x[i - 1] + x[N - i - 1]);
        gt = Get(1, 0, N / 2 - 1, 0, N / 2 - 1);
        ans = min(ans, gt.second - gt.first);
    }
    cout << ans << "\n";
    return 0;
}