#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <random>

using namespace std;

#ifdef KROL
#define dbg(x) cerr << #x << ":\n " << x << "\n";
#else
#define dbg(x);
#endif

typedef long long ll;
typedef long double ld;

#define int ll
#define sz(x) int(x.size())

//const ll inf = 1e16;
//
//const int maxn = 2e5 + 10;
//const int mod = 1e9 + 7;
//vector<pair<int, ll>> g[maxn];
//ll dpt[maxn], dps[maxn];
//
//vector<ll> dijkstra(int n, int s) {
//	vector<ll> d(n, inf);
//	d[s] = 0;
//	set<pair<ll, int>> q;
//	q.insert({ 0, s });
//	while (!q.empty()) {
//		auto [dist, v] = (*q.begin());
//		q.erase(q.begin());
//		if (d[v] != dist) continue;
//		for (auto& [u, w] : g[v]) {
//			if (d[u] > d[v] + w) {
//				d[u] = d[v] + w;
//				q.insert({ d[u], u });
//			}
//		}
//	}
//	return d;
//}
//vector<ll> ds, dt;
//
//void dfs1(int v) {
//	if (dpt[v] != -1) return;
//	dpt[v] = 0;
//	for (auto& [u, w] : g[v]) {
//		if (dt[v] == dt[u] + w) {
//			dfs1(u);
//			dpt[v] = (dpt[u] + dpt[v]) % mod;
//		}
//	}
//}
//
//void dfs2(int v) {
//	if (dps[v] != -1) return;
//	dps[v] = 0;
//	for (auto& [u, w] : g[v]) {
//		if (ds[v] == ds[u] + w) {
//			dfs2(u);
//			dps[v] = (dps[u] + dps[v]) % mod;
//		}
//	}
//}
//
//void solve() {
	//int n, m;
	//cin >> n >> m;
	//int s, t, L;
	//cin >> s >> t >> L;
	//s--, t--;

	//for (int i = 0; i < m; i++) {
	//	int v, u, w;
	//	cin >> v >> u >> w;
	//	v--, u--;
	//	g[v].push_back({ u, w });
	//	g[u].push_back({ v, w });
	//}
//	ds = dijkstra(n, s);
//	dt = dijkstra(n, t);
//	int sh = ds[t];
//	fill(dpt, dpt + n, -1);
//	fill(dps, dps + n, -1);
//	dpt[t] = 1;
//	dps[s] = 1;
//	dfs1(t);
//	dfs2(s);
//	ll ans = 0;
//	for (int v = 0; v < n; v++) {
//		ll add1 = 0;
//		int cnt = 0;
//		for (auto& [u, w] : g[v]) {
//			if (ds[v] + dt[v] != sh) continue;
//			if (ds[v] + w + dt[u] == L) {
//				ll add = (dps[v] * dpt[u]) % mod;
//				add1 = (add1 + add) % mod;
//				cnt++;
//			}
//		}
//		if ((L == sh && cnt > 1) || L != sh) {
//			ans = (ans + add1) % mod;
//		}
//	}
//	cout << ans << '\n';
//}

const int MOD = 1'000'000'007;

void solve() {
	int n, m;
	cin >> n >> m;
	int s, t, L;
	cin >> s >> t >> L;
	s--, t--;

	vector g(n, vector<pair<int, int>>());

	for (int i = 0; i < m; i++) {
		int v, u, w;
		cin >> v >> u >> w;
		v--, u--;
		g[v].push_back({ u, w });
		g[u].push_back({ v, w });
	}

	auto dijkstra = [&](int start) -> vector<int> {
		vector<int> d(n, 1e16);
		d[start] = 0;
		set<pair<int, int>> st{ { 0, start } };
		while (!st.empty()) {
			int u = st.begin()->second;
			st.erase(st.begin());
			for (auto [v, w] : g[u]) {
				if (d[u] + w < d[v]) {
					st.erase({ d[v], v });
					d[v] = d[u] + w;
					st.insert({ d[v], v });
				}
			}
		}
		return d;
	};

	vector<int> ds = dijkstra(s), dt = dijkstra(t);

	vector<int> kok(n);
	for (int u = 0; u < n; ++u) {
		for (auto [v, w] : g[u]) {
			if (ds[u] + w + dt[v] == ds[t]) {
				++kok[u];
			}
		}
	}

	vector<vector<int>> gs(n), gt(n);
	for (int u = 0; u < n; ++u) {
		for (auto [v, w] : g[u]) {
			if (ds[u] + w == ds[v]) {
				gs[u].push_back(v);
			}
			if (dt[u] + w == dt[v]) {
				gt[u].push_back(v);
			}
		}
	}

	vector<int> used(n);
	vector<int> ts, tt;

	auto gtS = [&](int u, auto&& gtS) -> void {
		used[u] = true;
		for (int v : gs[u]) {
			if (used[v]) continue;
			gtS(v, gtS);
		}
		ts.push_back(u);
	};

	auto gtT = [&](int u, auto&& gtT) -> void {
		used[u] = true;
		for (int v : gt[u]) {
			if (used[v]) continue;
			gtT(v, gtT);
		}
		tt.push_back(u);
	};

	used.assign(n, false);
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			gtS(i, gtS);
		}
	}

	used.assign(n, false);
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			gtT(i, gtT);
		}
	}

	vector<int> dps(n), dpt(n);
	dps[s] = dpt[t] = 1;

	reverse(ts.begin(), ts.end());
	for (int u : ts) {
		for (int v : gs[u]) {
			dps[v] += dps[u];
			dps[v] %= MOD;
		}
	}

	reverse(tt.begin(), tt.end());
	for (int u : tt) {
		for (int v : gt[u]) {
			dpt[v] += dpt[u];
			dpt[v] %= MOD;
		}
	}

	int ans = 0;
	//for (int i = 0; i < n; ++i) {
	//	cout << kok[i] << ' ';
	//}
	//cout << '\n';

	if (L == ds[t]) {
		if (dps[t] == 1) {
			cout << 0 << '\n';
		} else {
			cout << dps[t] << '\n';
		}
	} else {
		for (int u = 0; u < n; ++u) {
			for (auto [v, w] : g[u]) {
				if (ds[u] + w + dt[v] == ds[t] && kok[u] == 1) continue;
				if (kok[u] == 0 || ds[u] + w + dt[v] != L) continue;
				//cout << "!\n";
				//cout << u + 1 << ' ' << v + 1 << '\n';
				//cout << dps[u] << ' ' << dpt[v] << '\n';
				ans += dps[u] * dpt[v] % MOD;
				ans %= MOD;
			}
		}

		cout << ans << '\n';
	}
}

/*
10 11
1 10 7
1 2 1
2 4 1
2 3 1
3 5 1
4 5 1
5 6 1
6 8 1
6 7 1
7 9 1
8 9 1
9 10 1
*/

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);
	cout << fixed << setprecision(20);

	int T = 1;
	//cin >> T;

	for (int t = 1; t <= T; ++t) {
		solve();
	}
}