#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define sz(v) v.size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

struct LiChao {
    struct line {
        ll k, b = 1e18;

        line () {}
        line (ll _k, ll _b) : k(_k), b(_b) {}

        ll get(ll x) {
            return k * x + b;
        }
    };

    line f;
    ll lb, rb;
    LiChao* left = nullptr;
    LiChao* right = nullptr;

    LiChao() {}
    LiChao(int _l, int _r) : lb(_l), rb(_r) {}

    void add(line l) {
        int m = (lb + rb) / 2;
        if (l.get(m) < f.get(m)) swap(l, f);

        if (lb == rb) return;

        if (l.k > f.k && lb <= m - 1) {
            if (left == nullptr) {
                left = new LiChao(lb, m - 1);
            }
            left->add(l);
        } else if (m + 1 <= rb) {
            if (right == nullptr) {
                right = new LiChao(m + 1, rb);
            }
            right->add(l);
        }
    }

    void add(ll k, ll b) {
        add(line(k, b));
    }

    ll get_min(ll x) {
        int m = (lb + rb) / 2;
        if (m == x) {
            return f.get(x);
        }
        if (x < m) {
            return min(f.get(x), (left ? left->get_min(x) : ll(1e18)));
        } else {
            return min(f.get(x), (right ? right->get_min(x) : ll(1e18)));
        }
    }
};

vector<LiChao*> t;
void build(int n) {
    int size = 1 << (__lg(n) + bool(__builtin_popcount(n) - 1));
    t.assign(2 * size - 1, new LiChao(0, 2e9));
}

void update(int i, ll k, ll b, int x, int l, int r) {
    t[x]->add(k, b);
    if (l + 1 == r) {
        return;
    }
    int m = (l + r) / 2;
    if (i < m) {
        update(i, k, b, 2 * x + 1, l, m);
    } else {
        update(i, k, b, 2 * x + 2, m, r);
    }
}

ll get(int lq, int rq, ll val, int x, int l, int r) {
    if (rq <= l || r <= lq) return 1e18;
    if (lq <= l && r <= rq) return t[x]->get_min(x);

    int m = (l + r) / 2;
    ll a = get(lq, rq, val, 2 * x + 1, l, m);
    ll b = get(lq, rq, val, 2 * x + 2, m, r);
    return min(a, b);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, b, c;
    cin >> n >> b >> c;
    vector<ll> x(n), p(n);
    for (int i = 0; i < n; i++) cin >> x[i] >> p[i];


    // dp[j] = dp[i] + (x[j] - x[i]) * p[i];
    // dp[j] = dp[i] + x[j] * p[i] - x[i] * p[i];
    // dp[j] = x[j] * p[i] + (dp[i] - x[i] * p[i]);

    build(n);
    vector<ll> dp(n, 1e18);
    dp[0] = 0;

    auto upd = [&](int i) {
        update(i, p[i], dp[i] - x[i] * p[i], 0, 0, n);
    };

    upd(0);
    int cur = 0;
    for (int i = 1; i < n; i++) {
        while (x[i] - x[cur] > c) cur++;
        if (cur == i) break;
        dp[i] = get(cur, i, x[i], 0, 0, n);
        upd(i);
    }

    ll ans = 0;
    for (int i = 0; i < n; i++) {
        if (dp[i] <= b) {
            ll nv = x[i] + min(c, (b - dp[i]) / p[i]);
            ans = max(ans, nv);
        }
    }
    cout << ans;

    return 0;
}
