#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define sz(v) v.size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

struct minwindow {
    deque<pair<ll, ll>> a;

    void push(ll x, ll p) {
        while (!a.empty() && a.back().first > p) a.pop_back();
        a.emplace_back(p, x);
    }

    pair<ll, ll> get() {
        return a.front();
    }

    void pop(ll x) {
        if (a.front().second == x) a.pop_front();
    }

    ll size() {
        return a.size();
    }

    bool empty() {
        return size() == 0;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, b, c;
    cin >> n >> b >> c;
    vector<int> x(n), p(n);

    for (int i = 0; i < n; i++) cin >> x[i] >> p[i];

    minwindow mw;

    int i = 0;
    int cur = 0;
    int top = 0;
    while (i < n) {
        int add = min(b / p[i], c - top);
        int mx = top + add;
        while (cur < n && x[cur] - x[i] <= mx) {
            mw.push(x[cur], p[cur]);
            cur++;
        }
        mw.pop(x[i]);

        if (mw.empty()) {
            cout << x[i] + mx;
            return 0;
        }

        int xx = x[i];
        int cost = p[i];
        auto [best_p, best_x] = mw.get();
        if (best_p <= p[i]) {
            i++;
            while (p[i] > cost) {
                mw.pop(x[i]);
                i++;
            }

            if (top >= x[i] - xx) {
                top -= x[i] - xx;
            } else {
                int need = x[i] - xx - top;
                b -= need * cost;
                top = 0;
            }
        } else {
            i++;
            while (x[i] < best_x) {
                mw.pop(x[i]);
                i++;
            }


            top += add;
            b -= add * cost;
            top -= x[i] - xx;
        }
    }

    cout << x.back() + top + min(c - cur, b / p.back());

    return 0;
}
