#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
//#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define loop(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define pb push_back
#define f first
#define s second
#define inf 1e12

using namespace std;
ll INF = 1e12;


struct RMQ{
    vector<pair<ll, ll>> t;
    RMQ(vector<ll> &a) {
        t.assign(4 * a.size(), {});
        build(0, 0, a.size(), a);
    }

    void build(ll v, ll l, ll r, vector<ll> &a) {
        if (l + 1 == r) {
            t[v] = {a[l], l};
            return;
        }
        ll m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v] = min(t[2*v+1], t[2*v+2]);
    }

    pair<ll, ll> find(ll v, ll l, ll r, ll ql, ll qr, ll k) {
        //cout << "vertex: " << v << endl;
        //cout << "val: " << t[v].f << ' ' << t[v].s << endl;
        if (ql <= t[v].s && t[v].s < qr) {
            return t[v];
        }
        ll m = (l + r) / 2;
        pair<ll, ll> res{-1, -1};
        if (ql < m)
            res = find(2 * v + 1, l, m, ql, qr, k);
        cout << res.f << ' ' << res.s << endl;
        if (res.s == -1)
            res = find(2 * v + 2, m, r, ql, qr, k);
        else if (m < qr && res.f >= k) {
            res = min(find(2 * v + 2, m, r, ql, qr, k), res);
        }
        return res;
    }
};

void solve_c() {
    int n; cin >> n;
    vector<int> a;
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        a.push_back(x);
    }
    sort(a.begin(), a.end());
    ll mnp = 1e18, mxp = -1, ans = 1e18;
    for (int j = 0; j < n / 2; j++) {
        ll p = a[j] + a[n - j - 2];
        mnp = min(mnp, p);
        mxp = max(mxp, p);
        //cout << mnp << ' ' << mxp << endl;
    }
    ans = min(ans, mxp - mnp);
    for (int j = 0; j < n / 2; j++) {
        ll p = a[j + 1] + a[n - j - 1];
        mnp = min(mnp, p);
        mxp = max(mxp, p);
        //cout << mnp << ' ' << mxp << endl;
    }
    ans = min(ans, mxp - mnp);
    ll m = n / 2;
    for (int i = 1; i < m; i++) {
        ll p1, p2;
        p1 = a[n - i] + a[i - 1];
        p2 = a[n - i - 2] + a[i];
        mxp = max(max(p2, p1), mxp);
        mnp = min(min(p2, p1), mnp);
        //cout << mxp << ' ' << mnp << endl;
        ans = min(mxp - mnp, ans);
        p1 = a[n - i] + a[i + 1];
        p2 = a[n - i + 1] + a[i + 1];
        mxp = max(max(p2, p1), mxp);
        mnp = min(min(p2, p1), mnp);
        //cout << mxp << ' ' << mnp << endl;
        ans = min(mxp - mnp, ans);
    }
    /*for (int j = 0; j < n / 2; j++) {
        ll p = a[j + 1] + a[n - j];
        mnp = min(mnp, p);
        mxp = max(mxp, p);
        ans = min(ans, mxp - mnp);
    }*/
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n; cin >> n;
    vector<int> a;
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        a.push_back(x);
    }
    sort(a.begin(), a.end());
    vector<int> dist;
    for (int i = 1; i < n; i++) {
        dist.push_back(a[i] - a[i - 1]);
    }
    int m = dist.size() / 2;
    int dif = 0;
    for (int i = 0; i < m; i++) {
        dif -= dist[i];
        dif += dist[i + m];
    }
    int ans = 1e9;
    ans = min((int)min((int)abs(dif - dist[dist.size() - 1] + dist[m - 1]), (int)abs(dif + dist[0] - dist[m])), (int)min((int)abs(dif + dist[m - 1]), (int)abs(dif - dist[m])));
    cout << ans;
}
