#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).begin(), (a).end()
#define pub push_back

template <typename T, typename Cmp = less<T>>
using ordered_set =
    tree<T, null_type, Cmp, rb_tree_tag, tree_order_statistics_node_update>;

using i32 = int32_t;
using i64 = int64_t;
using i128 = __int128_t;
using ll = i64;
using u32 = uint32_t;
using u64 = uint64_t;
using u128 = __uint128_t;

using f32 = float;
using f64 = double;
using f128 = long double;

template <typename T1, typename T2>
istream& operator>>(istream& is, pair<T1, T2>& p) {
    return is >> p.first >> p.second;
}
template <typename T1, typename T2>
ostream& operator<<(ostream& os, const pair<T1, T2>& p) {
    return os >> p.first << " " << p.second;
}
template <typename T>
istream& operator>>(istream& is, vector<T>& v) {
    for (auto& e : v) is >> e;
    return is;
}
template <typename T>
ostream& operator<<(ostream& os, const vector<T>& v) {
    for (const auto& e : v) os << e << " ";
    return os;
}
template <typename T>
void chmin(T& a, const T& b) {
    if (b < a) a = b;
}
template <typename T>
void chmax(T& a, const T& b) {
    if (b > a) a = b;
}

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
using vi = vector<ll>;
using ld = long double;
using ii = pair<ll, ll>;
using vii = vector<ii>;

const ll R = 1 << 17;


constexpr i32 kMaxH = 405, kMaxW = 405;
constexpr i64 kMod = 1e9 + 7;
using matrix = array<array<i64, kMaxW>, kMaxH>;

matrix cnt{}, cntsums{}, cntcsums{}, dp{}, dpsums{}, dpcsums{};

i64 rect_csum(const matrix& csums, i32 i, i32 j) {
    if (i < 0 || j < 0)
        return 0;
    i64 res = 0;
    for (int k = 0; k <= i; ++k) {
        res = (res + csums[k][j] * (i - k + 1)) % kMod;
    }
    return res;
}

void update_sums(const matrix& ones, matrix& sums, i32 i, i32 j) {
    sums[i][j] = (sums[i][j - 1] + ones[i][j]) % kMod;
}
void update_csums(const matrix& sums, matrix& csums, i32 i, i32 j) {
    csums[i][j] = (csums[i][j - 1] + sums[i][j]) % kMod;
}
void update_all(const matrix& ones, matrix& sums, matrix& csums, i32 i, i32 j) {
    update_sums(ones, sums, i, j);
    update_csums(sums, csums, i, j);
}
void update(i32 i, i32 j) {
    update_all(cnt, cntsums, cntcsums, i, j);
    update_all(dp, dpsums, dpcsums, i, j);
}

void calc_cnt(i32 i, i32 j) {
    cnt[i][j] = (1 + rect_csum(cntcsums, i - 2, j - 2)) % kMod;
}
void calc_dp(i32 i, i32 j) {
    dp[i][j] = (i * j * cnt[i][j] + rect_csum(dpcsums, i - 2, j - 2)) % kMod;
}
void calc(i32 i, i32 j) {
    calc_cnt(i, j);
    calc_dp(i, j);
}

void solve() {
    i32 h, w;
    cin >> h >> w;
    for (int i = 1; i <= h; ++i) {
        for (int j = 1; j <= w; ++j) {
            calc(i, j);
            update(i, j);
        }
    }
    cout << dp[h][w] << "\n";
}
