#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
//#include <unordered_set>
#include <deque>
#include <bitset>
#include <iomanip>
#include <queue>
#include <cmath>
#include <ctime>
#include <numeric>
#include <string>

using namespace std; 

const unsigned int MOD = 1000000007;
const long long inf = 1e18;


struct tree {
    int n;
    vector <int> maxt;
    vector <int> mint;
    vector <int> sp;

    tree(vector <int>& A) {
        sp = A;
        n = A.size();
        maxt.resize(n * 4);
        mint.resize(n * 4);
        build(0, n, 0);
    }

    void build(int l, int r, int v) {
        if (r - l <= 1) {
            maxt[v] = sp[l];
            mint[v] = sp[l];
            return;
        }
        int m = (l + r) / 2;
        build(l, m, v * 2 + 1);
        build(m, r, v * 2 + 2);

        maxt[v] = max(maxt[v * 2 + 1], maxt[v * 2 + 2]);
        mint[v] = min(mint[v * 2 + 1], mint[v * 2 + 2]);
    }

    void change(int l, int r, int v, int pos, int val) {
        if (l > pos || r <= pos) {
            return;
        }
        if (r - l == 1) {
            maxt[v] += val;
            mint[v] += val;
            return;
        }
        int m = (l + r) / 2;
        change(l, m, v * 2 + 1, pos, val);
        change(m, r, v * 2 + 2, pos, val);

        maxt[v] = max(maxt[v * 2 + 1], maxt[v * 2 + 2]);
        mint[v] = min(mint[v * 2 + 1], mint[v * 2 + 2]);
    }
};


int main(void) {
    //freopen("censored.in", "r", stdin);
    //freopen("censored.out", "w", stdout);
    //cout << fixed << setprecision(20);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    //int t = 1; srand(time(0)); //cin >> t;
    //while (t--) solve();
    int n;
    cin >> n;
    vector <int> inp(n);
    for (int i = 0; i < n; i++) {
        cin >> inp[i];
    }
    sort(inp.begin(), inp.end());
    vector <int> sp;
    for (int i = 1; i <= n / 2; i++) {
        sp.push_back(inp[i] + inp[n - i]);
    }
    tree T(sp);
    int minh = 1e9;
    for (int i = 1; i < n; i++) {
        minh = min(minh, T.maxt[0] - T.mint[0]);
        T.change(0, (int)sp.size(), 0, min(n - i - 1, i - 1), inp[i] - inp[i - 1]);
    }
    cout << minh;
    return 0;
}
