#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
//#include <unordered_set>
#include <deque>
#include <bitset>
#include <iomanip>
#include <queue>
#include <cmath>
#include <ctime>
#include <numeric>
#include <string>

using namespace std; 

const unsigned int MOD = 1000000007;
const long long inf = 1e18;


struct tree {
    int n;
    vector <int> maxt;
    vector <int> mint;
    vector <int> sp;

    tree(vector <int>& A) {
        sp = A;
        n = A.size();
        maxt.resize(n * 4);
        mint.resize(n * 4);
        build(0, n, 0);
    }

    void build(int l, int r, int v) {
        if (r - l <= 1) {
            maxt[v] = sp[l];
            mint[v] = sp[l];
            return;
        }
        int m = (l + r) / 2;
        build(l, m, v * 2 + 1);
        build(m, r, v * 2 + 2);

        maxt[v] = max(maxt[v * 2 + 1], maxt[v * 2 + 2]);
        mint[v] = min(mint[v * 2 + 1], mint[v * 2 + 2]);
    }

    void change(int l, int r, int v, int pos, int val) {
        if (l > pos || r <= pos) {
            return;
        }
        if (r - l == 1) {
            maxt[v] += val;
            mint[v] += val;
            return;
        }
        int m = (l + r) / 2;
        change(l, m, v * 2 + 1, pos, val);
        change(m, r, v * 2 + 2, pos, val);

        maxt[v] = max(maxt[v * 2 + 1], maxt[v * 2 + 2]);
        mint[v] = min(mint[v * 2 + 1], mint[v * 2 + 2]);
    }
};


int main(void) {
    //freopen("censored.in", "r", stdin);
    //freopen("censored.out", "w", stdout);
    //cout << fixed << setprecision(20);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    //int t = 1; srand(time(0)); //cin >> t;
    //while (t--) solve();
    int n, B, C;
    cin >> n >> B >> C;
    vector <pair<int, int>> sp(n);
    for (int i = 0; i < n; i++) {
        cin >> sp[i].first >> sp[i].second;
    }
    sort(sp.begin(), sp.end());
    if (n == 1) {
        cout << min(C, B / sp[0].second);
        return 0;
    }
    int l = 0, r = 1, min_ind = 1, min_p = sp[1].second, filled = 0;
    while (l < n - 1) {
        if (r != n && sp[r].first - sp[l].first <= C) {
            if (sp[r].second < min_p) {
                min_p = sp[r].second;
                min_ind = r;
            }
            if (sp[r].second <= sp[l].second) {
                int need = sp[r].first - sp[l].first;
                int dlt = min(need, filled);
                need -= dlt;
                if (need * sp[l].second >= B) {
                    cout << sp[l].first + min(B / sp[l].second, C - filled) + filled;
                    return 0;
                }
                filled -= dlt;
                B -= need * sp[l].second;
                l = r;
                min_ind = l + 1;
                if (l + 1 == n) {
                    min_ind = l;
                    break;
                }
                min_p = sp[l + 1].second;
            }
            ++r;
        } else {
            --r;
            if (l == r) {
                cout << sp[l].first + min(B / sp[l].second, C - filled) + filled;
                return 0;
            }
            int will_fill = min(B / sp[l].second, C - filled);
            filled += will_fill;
            B -= sp[l].second * will_fill;
            int need = sp[min_ind].first - sp[l].first;
            int dlt = min(need, filled);
            need -= dlt;
            if (need * sp[l].second >= B) {
                cout << sp[l].first + min(B / sp[l].second, C - filled) + filled;
                return 0;
            }
            filled -= dlt;
            l = min_ind;
            ++r;
        }
    }
    int will_fill = min(B / sp[l].second, C - filled);
    filled += will_fill;
    B -= sp[l].second * will_fill;
    cout << sp[r - 1].first + filled;
    return 0;
}
