﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <iomanip>
#include <cstdio>
#include <set>
#include <map>
#include <bitset>
#include <unordered_map>
#include <random>
#include <ctime>
#include <stack>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;

struct node {
    node* l, * r;
    ll s;
    node() {
        l = r = nullptr;
        s = 0;
    }
    node(ll q) {
        l = r = nullptr;
        s = q;
    }
    node(node* L, node* R, ll a) {
        l = L;
        r = R;
        s = a;
    }
};

struct tree {
    node* root;
    ll sz;
    void build() {
        sz = 1;
        while (sz <= 1e9)
            sz *= 2;
        root = new node(2e9);
    }
    void upd(node* v, ll l, ll r, ll ql, ll qr, ll p) {
        if (!v->l)
            v->l = new node(2e9);
        if (!v->r)
            v->r = new node(2e9);
        if (r <= ql || l >= qr)
            return;
        if (ql <= l && r <= qr) {
            v->s = p;
            return;
        }
        ll m = (l + r) / 2;
        upd(v->l, l, m, ql, qr, p);
        upd(v->r, m, r, ql, qr, p);
        v->s = min(v->l->s, v->r->s);
    }
    void upd(ll ind, ll p) {
        upd(root, 0, sz, ind, ind + 1, p);
    }
    ll mn(node* v, ll l, ll r, ll ql, ll qr) {
        if (r <= ql || l >= qr || !v)
            return 2e9;
        if (ql <= l && r <= qr) {
            return v->s;
        }
        ll m = (l + r) / 2;
        return min(mn(v->l, l, m, ql, qr), mn(v->r, m, r, ql, qr));
    }
    ll mn(ll l, ll r) {
        return mn(root, 0, sz, l, r + 1);
    }
};

tree d;
int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif
    d.build();
	long long n, b, c;
	cin >> n >> b >> c;
	vector <long long> x(n), p(n);
    map <ll, set <ll>> m;
    map <ll, ll> m2;
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> p[i];
        d.upd(x[i], p[i]);
        m[p[i]].insert(x[i]);
        m2[x[i]] = p[i];
    }
	ll s = b, a = x[0], cn = p[0], bk = 0;
    while (1) {
        ll q = d.mn(a + 1, a + min(c, s / cn + bk)), newa;
        if (q == 2e9)
            break;
        if (q > cn) {
            newa = *m[q].upper_bound(a);
            if (s < cn * c)
                break;
            s -= cn * c;
            bk = c;
        }
        else {
            ll l = a, r = a + min(c, s / cn + bk);
            while (r - l > 1) {
                ll m = (l + r) / 2;
                if (d.mn(a + 1, m) > cn)
                    l = m;
                else
                    r = m;
            }
            newa = r;
            q = m2[newa];
        } 
        if ((newa - a - bk) * cn <= s) {
            s -= max(0ll, (newa - a - bk) * cn);
            if (bk >= newa - a)
                bk -= newa - a;
            else
                bk = 0;
        }
        else {
            break;
        }
        a = newa;
        cn = q;
    }
    cout << a + s / cn + bk;
}
