﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <iomanip>
#include <cstdio>
#include <set>
#include <map>
#include <bitset>
#include <unordered_map>
#include <random>
#include <ctime>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;

struct node {
	node* l, * r;
	ll s;
	node() {
		l = r = nullptr;
		s = 0;
	}
	node(ll q) {
		l = r = nullptr;
		s = q;
	}
	node(node* L, node* R, ll a) {
		l = L;
		r = R;
		s = a;
	}
};

struct tree {
	node* root;
	ll sz;
	void build() {
		sz = 1;
		while (sz <= 1e9)
			sz *= 2;
		root = new node(sz);
	}
	void upd(node* v, ll l, ll r, ll ql, ll qr) {
		if (!v->l)
			v->l = new node((r - l) / 2);
		if (!v->r)
			v->r = new node((r - l) / 2);
		if (r <= ql || l >= qr)
			return;
		if (ql <= l && r <= qr) {
			v->s = 0;
			return;
		}
		ll m = (l + r) / 2;
		upd(v->l, l, m, ql, qr);
		upd(v->r, m, r, ql, qr);
		v->s = v->l->s + v->r->s;
	}
	void upd(ll ind) {
		upd(root, 0, sz, ind, ind + 1);
	}
	ll spusk(node* v, ll l, ll r, ll k) {
		if (l == r - 1)
			return l;
		if (!v->l)
			v->l = new node((r - l) / 2);
		if (!v->r)
			v->r = new node((r - l) / 2);
		ll m = (l + r) / 2;
		if (v->l->s >= k) {
			return spusk(v->l, l, m, k);
		}
		return spusk(v->r, m, r, k - v->l->s);
	}
	ll spusk(ll k) {
		return spusk(root, 0, sz, k);
	}
};

tree d;
int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif
	d.build();
	int n, q;
	cin >> n >> q;
	vector <ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		d.upd(a[i]);
	}
	while (q--) {
		int k;
		cin >> k;
		cout << d.spusk(k) << ' ';
	}
}
